# -*- coding: utf-8 -*-
#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/60_PGM/_SRC/m03_00_Jednoduché_výrazy.py
"""
Kopie pasáží se záznamy komunikace se systémem realizovanými v IDLE
a uvedenými ve výpisech kapitoly: 3  Jednoduché výrazy.

Co se v kapitole naučíte
Tato kapitola vás nejprve seznámí se základní teorií týkající se
používání operátorů ve výrazech. Vysvětlí vám, jak se volají funkce,
a představí vám zabudované funkce pracující s jednoduchými čísly a stringy.
Poté probere nejdůležitější operátory pracující s čísly a stringy
a naučí vás je používat. Na závěr pak vysvětlí,
jak Python řeší problematiku rozdělení zadávaného kódu do více řádků.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01_00_Startujeme.
"""



##### 3.1.6 Asociativita binárních operátorů
############################################################################

(16 / 4 / 2)  ==  ((16 / 4) / 2)  ==  (4 / 2)  ==  2
# True


#---------------------------------------------------------------------------
(16 / (4 / 2))  ==  (16 / 2)  ==  8
# True


#---------------------------------------------------------------------------
4 ** 3 ** 2  ==  4 ** (3 ** 2) == 4 ** 9 == 262_144
# True


##### 3.2.4 Zabudované funkce s jednoduchými argumenty
############################################################################

# abs(x)
#---------------------------------------------------------------------------
abs(-3.14)
# 3.14
abs(1+1j)     #Absolutní hodnotou komplexního čísla je jeho velikost
# 1.4142135623730951


# ascii(objekt)
#---------------------------------------------------------------------------
ascii('Příliš ☺')
# "'P\\u0159\\xedli\\u0161 \\u263a'"


# bin(x)
#---------------------------------------------------------------------------
bin(5)
# '0b101'
bin(-10)
# '-0b1010'


# bool
#---------------------------------------------------------------------------


# complex([real[, imag]])
#---------------------------------------------------------------------------
complex()
# 0j
complex(1,2)
# (1+2j)


# float([x])
#---------------------------------------------------------------------------
float()
# 0.0
#!# float("Číslo 3.5")
# Traceback (most recent call last):
#   File "<pyshell#5>", line 1, in <module>
#     float("Číslo 3.5")
# ValueError: could not convert string to float: 'Číslo 3.5'
float('   -3.5\n')
# -3.5


# hex(i)
#---------------------------------------------------------------------------
hex(8364)
# '0x20ac'


# id(object)
#---------------------------------------------------------------------------


# chr(i)
#---------------------------------------------------------------------------
chr(0x20ac)   #Aby se znak zobrazil, musí být definován v použitém fontu
# '€'
chr(0x1D120)  #Houslový klíč není v použitém fontu => zobrazil se jako kód
# '\U0001d120'


# input([výzva])
#---------------------------------------------------------------------------
input("Zadej číslo: ")
# Zadej číslo: 123
# '123'


# int([x])
#---------------------------------------------------------------------------
int(3.9)   #Při převodu se nezaokrouhluje, ale usekává se desetinná část
# 3
int (-3.9) #Stejně je tomu i při převodu záporného čísla
# -3


# int(s, base)
#---------------------------------------------------------------------------
int('1010', 2)
# 10
int('1010', 16)
# 4112
int('No_nazdar', 36)
# 1856027718675


# len(s)
#---------------------------------------------------------------------------
len("")
# 0
len('12345')
# 5


# max(arg1, arg2 ...)
# min(arg1, arg2 ...)
#---------------------------------------------------------------------------
max(1, 7, 3)
# 7
min("Jenda", 'Franta', """Lojza""")
# 'Franta'


# oct(i)
#---------------------------------------------------------------------------
oct(255)
# '0o377'


# ord(c)
#---------------------------------------------------------------------------
ord('€')
# 8364


# print(argumenty)
#---------------------------------------------------------------------------
print('Hodnoty různých typů: ', 1, True, (3+1j), None)
# Hodnoty různých typů:  1 True (3+1j) None
print('Následuje:\tTabulátor\nNový řádek\rNávrat vozíku')
# Následuje:      Tabulátor
# Nový řádek Návrat vozíku


# range(stop),
# range(start, stop[, step])
#---------------------------------------------------------------------------


# repr
#---------------------------------------------------------------------------


# round(number[, ndigits])
#---------------------------------------------------------------------------
round(3.5)
# 4
round(1.23456, 3)
#1.235
round(987.654321, 2)
# 987.65
round(3, 2)
# 3


# str([object])
#---------------------------------------------------------------------------
repr('string')
# "'string'"
repr("string")
# "'string'"
repr("""string""")
# "'string'"
str('string')
# 'string'
str("string")
# 'string'


# type
#---------------------------------------------------------------------------


##### 3.3  Získání nápovědy
############################################################################

help(abs)
# Help on built-in function abs in module builtins:

# abs(x, /)
#     Return the absolute value of the argument.



#Výpis 3.1: Zadání argumentu nápovědy pomocí stringu
############################################################################
#!# help(not)  # Nekorektní použití operátoru not vyvolá syntaktickou chybu
# SyntaxError: invalid syntax
help('not')  # Název operátoru je třeba zadat jako text
# Boolean operations
# ******************
#
#    or_test  ::= and_test | or_test "or" and_test
#    and_test ::= not_test | and_test "and" not_test
#    not_test ::= comparison | "not" not_test
#
# In the context of Boolean operations, and also when expressions are
# ...    # a dalších 27 řádků výkladu



#Výpis 3.2: Přepnutí do režimu nápovědy a zpět
############################################################################
help()     # Všimněte si, že bez argumentů neznamená bez závorek
#
# Welcome to Python 3.7's help utility!
#
# If this is your first time using Python, you should definitely check out
# the tutorial on the Internet at https://docs.python.org/3.7/tutorial/.
#
# Enter the name of any module, keyword, or topic to get help on writing
# Python programs and using Python modules.  To quit this help utility and
# return to the interpreter, just type "quit".
#
# To get a list of available modules, keywords, symbols, or topics, type
# "modules", "keywords", "symbols", or "topics".  Each module also comes
# with a one-line summary of what it does; to list the modules whose name
# or summary contain a given string such as "spam", type "modules spam".
#
# help> hot
# No Python documentation found for 'hot'.
# Use help() to get the interactive help utility.
# Use help(str) for help on the str class.
#
# help> not
# Boolean operations
# ******************
#
# ...    # a dalších 32 řádků výkladu
#
# help>
#
# You are now leaving help and returning to the Python interpreter.
# If you want to ask for help on a particular object directly from the
# interpreter, you can type "help(object)".  Executing "help('string')"
# has the same effect as typing a particular string at the help> prompt.
# >>>



#Výpis 3.2: Současné přiřazení skupiny hodnot proměnným
############################################################################
10 / 3     #Běžný podíl
# 3.3333333333333335
10 // 3    #Celočíselný podíl celých čísel je celé číslo
# 3
10 % 3     #Zbytek po dělení celých čísel je celé číslo
# 1
10 / 5     #Běžný podíl – výsledkem je vždy reálné číslo
# 2.0
10 / 3.5   #Běžný podíl
# 2.857142857142857
10 // 3.5  #Celočíselný podíl reálných čísel je reálné číslo
# 2.0
10 % 3.5   #Zbytek po dělení
# 3.0
# >>>


#Umocňování
#---------------------------------------------------------------------------
4 ** 3 ** 2  ==  4 ** (3 ** 2)  ==  4 ** 9  ==  262_144
# True

#---------------------------------------------------------------------------
(4 ** 3) ** 2  ==  64 ** 2  ==  4096
# True



#Výpis 3.4: Komplexní číslo jako exponent – Eulerova rovnost
############################################################################
2.71828_18284_59045 ** 3.14159_26535_89793j  +  1
# 1.2246467991473532e-16j
round(abs(2.71828_18284_59045 ** 3.14159_26535_89793j + 1), 15)
# 0.0
# >>>



#Výpis 3.5: Nekonečna a nesmyslná čísla
############################################################################
#!# inf
# Traceback (most recent call last):
#   File "<pyshell#108>", line 1, in <module>
#     inf
# NameError: name 'inf' is not defined
float('INF'), float('+Inf'), float('-inf'), -float('inf'), float('NaN')
# (inf, inf, -inf, -inf, nan)
float('-inf') * -float('inf'),  float('inf')/float('inf')
# (inf, nan)
123 / float('inf'), 123 / float('-inf'), -123 / float('-inf')
# (0.0, -0.0, 0.0)
# >>>



#Výpis 3.6: Bitové posuny
############################################################################
bin(0b101001000 >> 3)   #Posun doprava o 3 bity
# '0b101001'
0b101    #Binárně 5
# 5
5 << 3   #Posun doleva o 3 bity je ekvivalentní násobení 2**3 = 8
# 40
bin(40)  #Zobrazíme výsledek ve dvojkové soustavě
# '0b101000'
# >>>



#Výpis 3.7: Sčítání textů
############################################################################
"Jedna" + """Dva""" + 'Tři'   '''Čtyři'''
# 'JednaDvaTřiČtyři'
#!# "Jedna: " + 1
# Traceback (most recent call last):
#   File "<pyshell#2>", line 1, in <module>
#     "Jedna: " + 1
# TypeError: can only concatenate str (not "int") to str
"Jedna: " + str(1)
# 'Jedna: 1'
# >>>



#Výpis 3.8 Násobení textů
############################################################################
'Bu' * 3
# 'BuBuBu'
3 * "Ha"
# 'HaHaHa'
#!# 3.0 * "Ha"
# Traceback (most recent call last):
#   File "<pyshell#78>", line 1, in <module>
#     3.0 * "Ha"
# TypeError: can't multiply sequence by non-int of type 'float'
# >>>



#Výpis 3.9: Indexace stringů
############################################################################
'Python'[0]
# 'P'
'Python'[3]
# 'h'
'Python'[-2]
# 'o'
# >>>



#Výpis 3.10: Zadání na více řádcích
############################################################################
"Dobrý \
den"
# 'Dobrý den'
print("První parametr ",
      "Druhý parametr ",
      )
# První parametr  Druhý parametr
print( 1,        #První
       2,        #Druhý
       )
# 1 2
#!# text = "První" +
# SyntaxError: invalid syntax
#!# text = "První" + #Před předčasným ukončením řádku není komentář povolen\
# SyntaxError: invalid syntax
# Samostatný komentář končící zpětným lomítkem \
"První " + \
"druhý"  #Komentář lze umístit až na poslední řádek víceřádkového zadání
# 'První druhý'
# >>>

