# -*- coding: utf-8 -*-
#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/60_PGM/_SRC/m05_00_Logické_hodnoty_a_operace.py
"""
Kopie pasáží se záznamy komunikace se systémem realizovanými v IDLE
a uvedenými ve výpisech kapitoly:  5  Logické hodnoty a operace.

Co se v kapitole naučíte
Tato kapitola se soustřeďuje na výklad práce s logickými hodnotami.
Vysvětlí základní pravidla, která umožňují chápat jakoukoliv hodnotu
jako logickou, a naučí vás pracovat s operátory,
jejichž operandy a/nebo výsledek jsou logické hodnoty.
V závěru probere možnosti práce s jednotlivými bity celých čísel
a naučí vás používat podmíněný výraz,
jehož hodnota závisí na splnění zadané podmínky.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01_00_Startujeme.
"""



#Výpis 5.1: Převody logických hodnot na čísla a jiných hodnot na logické
############################################################################
5 > 3     # 5 je opravdu věští než 3
# True
3 > 5     # Není pravda, že 3 je větší než 5
# False
False + True  # V případě potřeby se logické konstanty převedou na čísla
# 1
0 + True      # Hodnota konstanty True je 1
# 1
0 + False     # Hodnota konstanty False je 0
# 0
bool(0)       #Nula je převedena na False
# False
bool(123)     #Nenulové číslo je převedeno na True
# True
bool("")      #Prázdný řetězec je převeden na False
# False
bool('False') #Neprázdný řetězec je převeden na True
# True
# >>>



#Výpis 5.2: Zřetězené porovnávání
############################################################################
1 < 3 < 33 < 99
# True
1 < 3 == 3 > 2
# True
1 < 3 > 33 > 22
# False
low=10; high=33; val=20
0 < low <= val <= high < 100
# True
# >>>



#Výpis 5.3: Test totožnosti objektů
############################################################################
a = "Ahoj "
b = "světe"
ab = a + b
ab == a + b
# True
ab is (a + b)
# False
# >>>



#Výpis 5.4: Chování logických operátorů
############################################################################
a = 5 > 3         #Výsledek porovnání (logická hodnota) ukládám do proměnné
a
# True
not a
# False
'' and 'cokoliv'  #Levý operand je False => jeho hodnota je výsledkem
# ''
1 and ''          #Levý operand je True => výsledkem je hodnota pravého
# ''
'' or 'cokoliv'   #Levý operand je False => výsledkem je hodnota pravého
# 'cokoliv'
1 or ''           #Levý operand je True => jeho hodnota je výsledkem
# 1
not a or 0 or "" or "poslední" #První tři jsou False => výsledkem je hodnota posledního
# 'poslední'
# >>>



#Výpis 5.5: Chování bitových operátorů
############################################################################
bin(0b1100 & 0b1010)   #AND: 1 pouze tehdy, jsou-li oba bity 1
# '0b1000'
bin(0b1100 | 0b1010)   #OR:  0 pouze tehdy, jsou-li oba bity 0
# '0b1110'
bin(0b1100 ^ 0b1010)   #XOR: 1 právě tehdy, jsou li bity různé
# '0b110'
bin(~0b0101)
# '-0b110'
bin(~0b0101 & 0b1111)
# '0b1010'
# >>>



#Výpis 5.6: Použití podmíněného výrazu
############################################################################
pm = lambda x : ('plus ' if x>=0 else 'minus ') + str(abs(x))
pm(5), pm(-5)
# ('plus 5', 'minus 5')
pm = lambda x : 'plus ' if x>=0 else 'minus ' + str(abs(x))
pm(5), pm(-5)
# ('plus ', 'minus 5')
sign = lambda x : -1 if x<0 else 0 if x==0 else +1
sign(-10), sign(0), sign(+5)
# (-1, 0, 1)
# >>>

