#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/60_PGM/_SRC/m10_00_Rozhodování_a_cykly.py
"""
Kopie pasáží se záznamy komunikace se systémem realizovanými v IDLE
a uvedenými ve výpisech kapitoly:  10  Rozhodování a cykly.

Co se v kapitole naučíte
Tato kapitola probere příkazy, v nichž se rozhodujete o dalším postupu.
Nejprve představí podmíněný příkaz s jeho různými modifikacemi,
pak předvede možnosti rekurzivního volání, a poté se zaměří na cykly,
což jsou programové konstrukce řídící opakování provádění zadané části
programu. Nejprve projde různé druhy cyklů, u nichž o pokračování rozhoduje
splnění nějaké podmínky. Poté se soustředí na cyklus for používaný při
postupném zpracovávání dat dodávaných nějakým zdrojem.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01_00_Startujeme.
"""



#Výpis 10.1: Ukázka použití jednoduchého podmíněného příkazu
############################################################################
def ifThen(číslo):
    """Doplní číslo slovním vyjádřením znaménka."""
    znam = 'plus '      # Předpokládám, že číslo je kladné
    if číslo < 0:       # Oprava pro záporné číslo
        znam  = 'minus '
        číslo = -číslo
    print (znam, číslo);

ifThen(5); ifThen(-7)
# plus 5
# minus 7
# >>>



#Výpis 10.2: Ukázka použití úplného podmíněného příkazu
############################################################################
def ifElse(číslo):
    """Doplní číslo slovním vyjádřením znaménka."""
    if (číslo > 0):     # Verze pro kladná čísla
        text = "plus " + str(číslo)
    else:               # Verze pro záporná čísla
        text = "minus " + str(-číslo)
    print(text)

ifElse(5);ifElse(-7)
# plus 5
# minus 7
def ifExpr(číslo):
    """Tiskne hodnotu podmíněného výrazu."""
    print( ("plus "  + str( číslo))  if  (číslo > 0)
      else ("minus " + str(-číslo)) )

ifExpr(5); ifExpr(-7)
# plus 5
# minus 7
# >>>



#Výpis 10.3: Ukázky použití rozšířeného podmíněného příkazu
############################################################################
def akt_1(sezona):
    """Těla jsou na stejném řádku jako hlavička příkazu."""
    if   sezona == 'zima'  : akt = 'spí'
    elif sezona == 'jaro'  : akt = 'kvete'
    elif sezona == 'léto'  : akt = 'zraje'
    elif sezona == 'podzim': akt = 'plodí'
    else: return "Špatně zadaná sezóna: " + str(sezona)
    return 'Je-li ' + str(sezona) + ', jabloň ' + str(akt)

print(akt_1('jaro'));print(akt_1('podzim'));print(akt_1('nevim'))
# Je-li jaro, jabloň kvete
# Je-li podzim, jabloň plodí
# Špatně zadaná sezóna: nevim
def akt_2(sezona):
    """Těla nejsou na stejném řádku jako hlavička příkazu."""
    if   sezona == 'zima':
         akt = 'spí'
    elif sezona == 'jaro':
         akt = 'kvete'
    elif sezona == 'léto':
         akt = 'zraje'
    elif sezona == 'podzim':
         akt= 'plodí'
    else:
         return "Špatně zadaná sezóna: " + str(sezona)
    return 'Je-li ' + str(sezona) + ', jabloň ' + str(akt)

print(akt_2('jaro'));print(akt_2('podzim'));print(akt_2('nevím'))
# Je-li jaro, jabloň kvete
# Je-li podzim, jabloň plodí
# Špatně zadaná sezóna: nevím
# >>>



#Výpis 10.4: Ukázky definic funkcí používajících rekurzivní volání
############################################################################
def recDemo(n, s=''):
    """Demonstrace rekurzivního volání."""
    print(s, '==>', n)               # Funkce ohlašuje svůj start
    if n>0 : recDemo(n-1, s+'  ')    # Hlášení bude posunuté o dvě mezery
    print(s, n , '<==')              # Funkce ohlašuje svoje ukončení

recDemo(5)
#  ==> 5
#    ==> 4
#      ==> 3
#        ==> 2
#          ==> 1
#            ==> 0
#            0 <==
#          1 <==
#        2 <==
#      3 <==
#    4 <==
#  5 <==
def r():    # Demonstrace neukončeného rekurzivního volání
    r()     # Neexistence ukončovací podmínky vede k nekonečné rekurzi

r()   # Nekonečná rekurze vede k přetečení zásobníku
# Traceback (most recent call last):
#   File "<pyshell#179>", line 1, in <module>
#     r()
#   File "<pyshell#178>", line 2, in r
#     r()
#   File "<pyshell#178>", line 2, in r
#     r()
#   File "<pyshell#178>", line 2, in r
#     r()
#   [Previous line repeated 991 more times]
# RecursionError: maximum recursion depth exceeded
def factR(n):
    """Rekurzivní definice faktoriálu."""
    if n<=1 : return 1
    return n * factR(n-1)

factR(5)
#120
factR(99)    # Python umožňuje spočítat i faktoriál velkých čísel
#933262154439441526816992388562667004907159682643816214685929638952175999932299156089414639761565182862536979208272237582511852109168640000000000000000000000
#>>>



#Výpis 10.5: Ukázky definic funkcí používajících cyklus while
############################################################################
def countDown(n):
    """Vytiskne zadaný počet znaků – a po nich slovo BUM"""
    while n>0:
        print(n, end='-')
        n -= 1
    print('BUM')

countDown(5)
# 5-4-3-2-1-BUM
def factW(n):
    """Faktoriál počítaný pomocí cyklu while."""
    f = 1      # Hodnota vracená v případě, když n <= 1
    while n > 1:
        f *= n
        n -= 1
    return f

factW(5)
# 120
# >>>



#Výpis 10.6: Nekonečný cyklus
############################################################################
def infinite():
        """Spustí prázdný nekonečný cyklus, který bude nutné přerušit zvenku."""
        while True: pass
        print('Hotovo')

infinite ()
# Traceback (most recent call last):
#   File "<pyshell#2>", line 1, in <module>
#     infinite()
#   File "<pyshell#1>", line 2, in infinite
#     while True: pass
# KeyboardInterrupt
# >>>



#Výpis 10.7: Použití příkazu break
############################################################################
def cumul(time: int,       # Kolik období se bude úročit
          interest: float, # Velikost úroku
         ) -> float:       # Akumulovaný násobek základní částky
    """Spočte násobek zadané částky pro zadaný počet úrokových období."""
    multiplier = 1 + interest/100
    sum = 1.    # Základní částka
    n   = 1     # Pořadové číslo období
    print("Průběžné násobky základní částky: 1,000", end='')
    while True:
        sum *= multiplier
        if n >= time : break    #---------->
        print(' - ', n, ':', round(sum,3), sep='', end='')
        n += 1
    print('\nPo ', time, ' obdobích se při úroku ', interest, ' % naspoří ',
          round(sum,3), '-násobek základní částky.', sep='')

cumul(5,5)
# Průběžné násobky základní částky: 1,000 - 1:1.05 - 2:1.103 - 3:1.158 - 4:1.216
# Po 5 obdobích se při úroku 5 % naspoří 1.276-násobek základní částky.
# >>>



#Výpis 10.8: Použití přiřazovacího výrazu v hlavičce cyklu while
############################################################################
seznam = 'Účastníci: '
while ((osoba:=input('Jméno: ')) != ''):
    seznam += osoba + ', '
    print(seznam)

# Jméno: Franta
# Účastníci: Franta,
# Jméno: Pepa
# Účastníci: Franta, Pepa,
# Jméno: Alena
# Účastníci: Franta, Pepa, Alena,
# Jméno:
while (True):
        osoba = input('Jméno: ')
        if (osoba == ''): break
        seznam += osoba + ', '
        print(seznam)

# Jméno: Kazimír
# Účastníci: Franta, Pepa, Alena, Kazimír,
# Jméno:
# >>>



#Výpis 10.9: Cyklus while využívající větev else
############################################################################
def isPrime(n: int):
    """Vypíše, zda je zadaný argument prvočíslem."""
    d = n // 2          # Dělitel může být nejvýše poloviční
    while d > 1:
        if n % d == 0:  # Zbytek po dělení
            print(n, 'je dělitelné číslem', d, end=' # ')
            break       # Větev else se přeskakuje
        d -= 1
    else: # Standardní konec:
        print(n, 'je prvočíslo', end=' ! ')
    print('KONEC TESTU')

isPrime(35); isPrime(37)
# 35 je dělitelné číslem 7 # KONEC TESTU
# 37 je prvočíslo ! KONEC TESTU
# >>>



#Výpis 10.10: Použití příkazu continue
############################################################################
def sum3xC(x,   # Číslo, jehož následníci se mají sčítat
           n):  # Počet sčítaných následníků nedělitelných třemi
    """Sečte zadaný počet čísel nedělitelných třemi následujících
       za zadaným číslem."""
    s = 0
    while n > 0:
        x += 1
        if x % 3 == 0:
            print(x, "ne", sep='', end=' ')
            continue
        s += x
        print("+", x, end=' ')
        n -= 1
    print("=", s)

sum3xC(7, 7)
# + 8 9ne + 10 + 11 12ne + 13 + 14 15ne + 16 + 17 = 89
def sum3xE(x,    # Číslo, jehož následníci se mají sčítat
           n):   # Počet sčítaných následníků nedělitelných třemi
    """Sečte zadaný počet čísel nedělitelných třemi následujících
       za zadaným číslem."""
    s = 0
    while n > 0:
        x += 1
        if x % 3 == 0:
            print(x, "ne", sep='', end=' ')
        else:
          s += x
          print("+", x, end=' ')
          n -= 1
    print("=", s)

sum3xE(5, 5)
# 6ne + 7 + 8 9ne + 10 + 11 12ne + 13 = 49
# >>>



#Výpis 10.11: Použití příkazu for se zdrojem definovaným jako sada hodnot
############################################################################
for val in (i:=1), 2+3j, 'čtyři', print, '5**3='+str(5**3):
        print(i, '. položka = ', repr(val), sep='')
        i += 1

# 1. položka = 1
# 2. položka = (2+3j)
# 3. položka = 'čtyři'
# 4. položka = <built-in function print>
# 5. položka = '5**3=125'
# >>>



#Výpis 10.12: Použití příkazu for se zdrojem generovaným funkcí range()
############################################################################
for x in range(3*(step:=12), 99, step):
    print(x, "-", x*x, sep='', end=', ')

# 36-1296, 48-2304, 60-3600, 72-5184, 84-7056, 96-9216,
step = 12
for x in range(3*step, 99, step):
    print(x, "-", x*x, sep='', end=', ')

# 36-1296, 48-2304, 60-3600, 72-5184, 84-7056, 96-9216,
# >>>



#Výpis 10.13: Indexace znaků v textovém řetězci – stringu
############################################################################
def indexing(s):
    n = len(s)
    print('Text: "' + s + '", znaků=' + str(n))
    for i in range(n):
        print(' ' + str(i) + ":" + s[i] + '  ', end='')
    print()
    for i in range(-1, -n-1, -1):
        print(i, ':', s[i], '  ', sep='', end='')

indexing('Python')
# Text: "Python", znaků=6
#  0:P   1:y   2:t   3:h   4:o   5:n
# -1:n  -2:o  -3:h  -4:t  -5:y  -6:P
# >>>



#Výpis 10.14: Zpracování jednotlivých znaků v textovém řetězci bez použití indexů
############################################################################
for c in "Dobrý den":
    print('(', c, ') ', sep='', end='')

# (D) (o) (b) (r) (ý) ( ) (d) (e) (n)
# >>>



#Výpis 10.15: Ukázka zanořování cyklů
############################################################################
def seq_in_radix(radix):
    """Vypíše posloupnost 3ciferných hodnot v zadané číselné soustavě."""
    for c2 in range(radix):
        for c1 in range(radix):
            for c0 in range(radix):
                s = str(c2) + str(c1) + str(c0)
                print(s, end=', ')

seq_in_radix(2)
# 000, 001, 010, 011, 100, 101, 110, 111,
seq_in_radix(3)
# 000, 001, 002, 010, 011, 012, 020, 021, 022, 100, 101, 102, 110, 111, 112, 120, 121, 122, 200, 201, 202, 210, 211, 212, 220, 221, 222,
# >>>



#Výpis 10.16: Příkaz for s postupným použitím více zdrojů
############################################################################
for x in range(1, 5), range(11, 15): print(x, end=', ')

# range(1, 5), range(11, 15)
for x in range(1, 5),: print(x, end=', ')

# range(1, 5),
for source in range(1, 5), range(11, 15):
    for x in source: print(x, end=', ')

# 1, 2, 3, 4, 11, 12, 13, 14,
# >>>



#Výpis 10.17: Definice a použití generátorové funkce gen1() demonstrující některé
#             možnosti použití výrazu yield
############################################################################
def gen1(number):
    """Funkce demonstruje některé možnosti použití výrazu yield."""
    yield('Start: ' + str(number))
    for s in ('První', 'Druhý', 'Třetí'):
        yield ('\n' + s + ': ')
        for n in range(number, number+3):
            yield n
        number = n
    yield '\nKONEC\n'

for x in gen1(17): print(x, end='')

# Start: 17
# První: 171819
# Druhý: 192021
# Třetí: 212223
# KONEC
# >>>



#Výpis 10.18: Ovlivnění generátoru prostřednictvím výrazy yield a funkce send()
############################################################################
# >>> \
def gener(up_to):
    index = 0
    while index < up_to:
        jump = yield index
        if jump is None:  jump = 1
        index += jump

iter = gener(7)
print(next(iter), iter.send(2), next(iter), iter.send(-1))
# 0 2 3 2
for x in iter: print(x, end=' ')
# 3 4 5 6



#Výpis 10.19: Definice generátorových funkcí gen2() a gen21 demonstrující použití
#             výrazu yield from
############################################################################
def gen2(x, y):
    """Generátorová funkce využívající výrazy/příkazy yield from."""
    for n in range(x, x+y):
        y = yield from gen21(n)
        print ('from[', str(y), sep='', end=']')
        y = yield '# '
        print (' {', y, end=' }\n')

def gen21(n):
    """Postupně poskytne první tři mocniny svého argumentu."""
    for x in range (1, 4):
        yield n
        n *= n

for i in gen2(5, 3): print(i, end='-')

# 5-25-625-from[None]# - { None }
# 6-36-1296-from[None]# - { None }
# 7-49-2401-from[None]# - { None }
# >>>



#Výpis 10.20: Příkaz for s větví else
############################################################################
def for_else(start, step):
    """Vypíše prvních pět členů aritmetické řady se zadaným startem
    a krokem; objeví-li se však třináctka, výpis ukončí.
    """
    for n in range(start, start+5*step, step):
        if n == 13: break
        print(n, end='-')
    else:
        print('Povedlo se')
        return
    print('Zakopli jsme o třináctku')

for_else(0, 5)
# 0-5-10-15-20-Povedlo se
for_else(9, 2)
# 9-11-Zakopli jsme o třináctku
# >>>



#Výpis 10.21: Zobrazení cyklu for s větví else v okně konzole
############################################################################
for n in range(0, 5):
    if n == 13: print('Zakopli jsme o třináctku'); break
    print(n, end='-')
else:
    print('Povedlo se')

# 0-1-2-3-4-Povedlo se
# >>>



#Výpis 10.22: Zobrazení cyklu for s větví else v příkazovém okně IDLE
#
# Zdrojový kód neodpovídá, zadání je v r10_00_Rozhodování_a_cykly.pyrec
############################################################################
for n in range(0, 5):
    if n == 13: print('Zakopli jsme o třináctku'); break
    print(n, end='-')
else:
    print('Povedlo se')

# SyntaxError: unindent does not match any outer indentation level
for n in range(0, 5):
    if n == 13: print('Zakopli jsme o třináctku'); break
    print(n, end='-')
else:
    print('Povedlo se')

# 0-1-2-3-4-Povedlo se
# >>> \
for n in range(0, 5):
    if n == 13: print('Zakopli jsme o třináctku'); break
    print(n, end='-')
else:
    print('Povedlo se')

# 0-1-2-3-4-Povedlo se
# >>>



#Výpis 10.X: Popisek
############################################################################
