#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/60_PGM/_SRC/m11_00_Ošetřování_chyb.py
"""
Kopie pasáží se záznamy komunikace se systémem realizovanými v IDLE
a uvedenými ve výpisech kapitoly:  11  Ošetřování chyb.

Co se v kapitole naučíte
Tato kapitola vám vysvětli problematiku výjimek,
jejich vyhazování (vyvolávání) a zachytávání.
Probere složený příkaz try s jeho větvemi except, else a finally.
Poté vysvětlí, jak výjimku vyhodit. Na závěr představí příkaz assert.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01_00_Startujeme.
"""



#Výpis 11.1: Ukázky syntaktických chyb a reakcí na ně při zadávání příkazů
#            v prostředí IDLE
############################################################################
#!# text = "První" +   # Předčasné ukončení řádku
# SyntaxError: invalid syntax
#!# help(not)   # Nekorektní použití operátoru not
# SyntaxError: invalid syntax
#!# while True print('Hello world')   # Chybějící dvojtečka za hlavičkou cyklu
# SyntaxError: invalid syntax
#!# "Neukončený text
# SyntaxError: EOL while scanning string literal
#!# 0123   #Špatně zapsané číslo - počáteční nula je zakázaná
# SyntaxError: leading zeros in decimal integer literals are not permitted; use an 0o prefix for octal integers
# >>>



#Výpis 11.2: Ukázky syntaktických chyb a reakcí na ně při zadávání příkazů
#            z konzolového okna
############################################################################
#!# def err_demo():
#!#     """Funkce obsahující syntaktickou chybu."""
#!#     while True print('Hello world')
#   File "<stdin>", line 3
#     while True print('Hello world')
#                ^
# SyntaxError: invalid syntax
import m11_01_Chyby
# Traceback (most recent call last):
#   File "<stdin>", line 1, in <module>
#   File "P:\60_PGM\_SRC\m11_01_Chyby.py", line 9
#     text = "První" +   # Předčasné ukončení řádku
#                        ^
# SyntaxError: invalid syntax
# >>>



#Výpis 11.3: Zopakovaný výpis 7.10 ze strany 121 zobrazující načtení
#            třetí verze modulu m07_01_Modul z výpisu 7.7 na straně 113
############################################################################
#!# reload(m)

# ===== START načítání modulu m07_01_Modul nějaký výraz
# Původní hodnoty: Druhá verze 23456 Stále druhá verze
# Traceback (most recent call last):
#   File "<pyshell#35>", line 1, in <module>
#     reload(m)
#   File "Ca:\_PGM\Python\Python38\lib\importlib\__init__.py", line 169, in reload
#     _bootstrap._exec(spec, module)
#   File "<frozen importlib._bootstrap>", line 604, in _exec
#   File "<frozen importlib._bootstrap_external>", line 778, in exec_module
#   File "<frozen importlib._bootstrap>", line 219, in _call_with_frames_removed
#   File "P:\60_PGM\m07_01_Modul.py", line 13, in <module>
#     num  = 3_456 / 0
# ZeroDivisionError: division by zero
# >>>



#Výpis 11.4: Ukázka zachycení a ošetření výjimky
############################################################################
def input_int() -> int:
    """Vrátí celé číslo zadané uživatelem z klávesnice.
       Základní podoba příkazu s větví try a jednou větví except.
    """
    while True:
        try:
            x = int(input('Zadejte celé číslo: '))
            break   # Korektní zadání, můžeme cyklus ukončit
        except ValueError:
            print('To nebylo platné celé číslo! Zkuste to znovu...')
    return x

print('\nZadali jste číslo:', input_int())
# Zadejte celé číslo: 0xabcd
# To nebylo platné celé číslo! Zkuste to znovu...
# Zadejte celé číslo: 0123
#
# Zadali jste číslo: 123
# >>>



#Výpis 11.5: AHA-příklad používající příkaz try se všemi dostupnými větvemi
############################################################################
# >>> \
def input_int_full_try() -> int:
    """Vrátí celé číslo zadané uživatelem z klávesnice.
       Hlavním účelem je demonstrovat úplnou podobu příkazu
       a funkci jednotlivých větví při vyhození a nevyhození výjimky.
    """
    entered = False      # Ještě nebylo zadáno
    while not entered:   # Dokud nebude korektně zadáno
        try:
            x = int(input('----------------------\nZadejte celé číslo: '))
            print('++ Zadáno')
            entered = True    # Aby se cyklus ukončil
        except ValueError:
            print('-- To nebylo platné celé číslo! Zkuste to znovu...')
        else:
            print('ee Prochází se větev else')
        finally:
            print('ff Prochází se větev finally')
        print('cc Pokračujeme v těle cyklu - opakovat =', not entered)
    print('zz Cyklus ukončen, vrátili jsme se do těla funkce')
    return x

print('\nZadali jste číslo:', input_int_full_try())
# ----------------------
# Zadejte celé číslo: 1.5
# -- To nebylo platné celé číslo! Zkuste to znovu...
# ff Prochází se větev finally
# cc Pokračujeme v těle cyklu - opakovat = True
# ----------------------
# Zadejte celé číslo: 3j
# -- To nebylo platné celé číslo! Zkuste to znovu...
# ff Prochází se větev finally
# cc Pokračujeme v těle cyklu - opakovat = True
# ----------------------
# Zadejte celé číslo: 999
# ++ Zadáno
# ee Prochází se větev else
# ff Prochází se větev finally
# cc Pokračujeme v těle cyklu - opakovat = False
# zz Cyklus ukončen, vrátili jsme se do těla funkce
#
# Zadali jste číslo: 999



#Výpis 11.6: Měření rychlosti počítače a přesnosti odhadu času
############################################################################
def kbd(times):
    """Umožňuje měřit přesnost uživatele při odhadu času
       a jako vedlejší efekt měří rychlost počítače.
    """
    from time import time
    for p in range(0, times):
        t1 = time()
        try:
            n = 0
            while True: n += 1
        except KeyboardInterrupt:
            t2 = time()
            print(p, '. pokus, ', n, ' běhů, ', s:=round(t2-t1, 3), ' sekund, ',
                  round(n/s/1e6, 3), ' běhů za mikrosekundu', sep='')
    print('Konec testu')

kbd(3)
# 0. pokus, 64419461 běhů, 2.934 sekund, 21.956 běhů za mikrosekundu
# 1. pokus, 75577335 běhů, 3.371 sekund, 22.42 běhů za mikrosekundu
# 2. pokus, 68387616 běhů, 2.927 sekund, 23.364 běhů za mikrosekundu
# Konec testu
# >>>



#Výpis 11.7: Funkce assert_stmt() demonstrující funkci příkazu assert
############################################################################
def assert_stmt(test, info=''):
    if __debug__:
        if not test:
            raise AssertionError(info)

