# -*- coding: utf-8 -*-
#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/60_PGM/_SRC/m12_00_Seznamy.py
"""
Kopie pasáží se záznamy komunikace se systémem realizovanými v IDLE
a uvedenými ve výpisech kapitoly:  12  Seznamy.

Co se v kapitole naučíte
Tato kapitola představuje seznamy jako základní proměnné posloupnosti dat.
Nejprve vysvětlí rozdíl mezi neměnnými a proměnnými objekty
a pak probere jednotlivé možnosti vytváření a případné modifikace seznamů.
Na závěr pak ukáže, jak se pracuje s vícerozměrnými seznamy.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01_00_Startujeme.
"""



#Výpis 12.1: Demonstrace neměnnosti objektů
############################################################################
int1 = int2 = 5
int1 += 1
print ('int1 =', int1, '\nint2 =', int2)
# int1 = 6
# int2 = 5
str1 = str2 = "Python"
str1 += " je skvělý"
print ('str1 =', str1, '\nstr2 =', str2)
# str1 = Python je skvělý
# str2 = Python
# >>>



#Výpis 12.2: Vytváření seznamů pomocí literálů
############################################################################
lst = [];   lst
# []
(lst := [17, 'červen', (2**3 < 10), range(0, 100, 11), [1, 2, 3]])
# [17, 'červen', True, range(0, 100, 11), [1, 2, 3]]
# >>>



#Výpis 12.3: Vytváření seznamů pomocí funkce list()
############################################################################
list('Python')
# ['P', 'y', 't', 'h', 'o', 'n']
list(range(0, 55, 11))
# [0, 11, 22, 33, 44]
from utils import gen_square
# ===== START načítání modulu utils #####
# ===== KONEC načítání modulu utils #####
list(gen_square(5))
# [0, 1, 4, 9, 16, 25]
list()
# []
# >>>



#Výpis 12.4: Vytváření seznamů z jiných seznamů pomocí sčítání a násobení
############################################################################
la = [1, 2];  lb = [10, 20]
(lab := la + lb)
# [1, 2, 10, 20]
(lac := 2*la + 2*lb)
# [1, 2, 1, 2, 10, 20, 10, 20]
la += lb;   la   # Zde to není výraz, zde se uvedení proměnné nevyhnu
# [1, 2, 10, 20]
lb *= 3;   lb    # I zde musím o zobrazení hodnoty požádat explicitně
# [10, 20, 10, 20, 10, 20]
# >>>



#Výpis 12.5: Vytvoření seznamu pomocí generátorové notace
############################################################################
s = []
for c in 'Python': s.append(c)

s
# ['P', 'y', 't', 'h', 'o', 'n']
[c for c in 'Python']
# ['P', 'y', 't', 'h', 'o', 'n']
[x*x for x in range(3, 30, 3)]
# [9, 36, 81, 144, 225, 324, 441, 576, 729]
[x*x for x in range(3, 30, 3) if x&1 != 0]
# [9, 81, 225, 441, 729]
(list3 := [x for x in range(3, 30, 3) if x&1 != 0])
# [3, 9, 15, 21, 27]
[[x, x*x] for x in list3]
# [[3, 9], [9, 81], [15, 225], [21, 441], [27, 729]]
[[x,y,z] for x in [0,1] for y in [0,1] for z in [0,1] if not(x==y==z)]
# [[0, 0, 1], [0, 1, 0], [0, 1, 1], [1, 0, 0], [1, 0, 1], [1, 1, 0]]
# >>>



#Výpis 12.6: Použití funkcí append() a extend()
############################################################################
la = [1, 2];   lb = [10, 20];   lc = [8, 9]
lc.append(la);   lc
# [8, 9, [1, 2]]
lc.extend(lb);   lc
# [8, 9, [1, 2], 10, 20]
la.extend(range(3, 10, 3));   la
# [1, 2, 3, 6, 9]
la.append(range(3, 10, 3));   la
# [1, 2, 3, 6, 9, range(3, 10, 3)]
lc
# [8, 9, [1, 2, 3, 6, 9, range(3, 10, 3)], 10, 20]
la += [11, 22, 33];   la
# [1, 2, 3, 6, 9, range(3, 10, 3), 11, 22, 33]
lc
# [8, 9, [1, 2, 3, 6, 9, range(3, 10, 3), 11, 22, 33], 10, 20]
# >>>



#Výpis 12.7: Demonstrace chování proměnných objektů
############################################################################
lst1 = lst2 = ["Python"]
lst1 += [" je skvělý"]
print ('lst1 =', lst1, '\nlst2 =', lst2)
# lst1 = ['Python', ' je skvělý']
# lst2 = ['Python', ' je skvělý']
# >>>



#Výpis 12.8: Postupné budování seznamu
############################################################################
lst = []
while ((x:=input('Hodnota: ')) != ''):
    lst.append(x)
    print(lst)

# Hodnota: ahoj
# ['ahoj']
# Hodnota: další
# ['ahoj', 'další']
# Hodnota: už končím
# ['ahoj', 'další', 'už končím']
# Hodnota:
# >>>



#Výpis 12.9: Rozšiřování seznamu přičítáním
############################################################################
lst = [1, 2];   (lst1 := lst)
# [1, 2]
lst += [3, 4];      lst1
# [1, 2, 3, 4]
lst1 is lst
# True
lst += range(0, 30, 11);   lst
# [1, 2, 3, 4, 0, 11, 22]
lst += 'ABC';   lst
# [1, 2, 3, 4, 0, 11, 22, 'A', 'B', 'Ca']
lst += (99, 88);      lst1
# [1, 2, 3, 4, 0, 11, 22, 'A', 'B', 'Ca', 99, 88]
lst += {222, 333};   lst
# [1, 2, 3, 4, 0, 11, 22, 'A', 'B', 'Ca', 99, 88, 333, 222]
lst += {'a':10, 'b':11};   lst
# [1, 2, 3, 4, 0, 11, 22, 'A', 'B', 'Ca', 99, 88, 333, 222, 'a', 'b']
lst =[1, 'A'];   lst += gen_square(5, 3);   lst
# [1, 'A', 9, 16, 25]
# >>>



#Výpis 12.10: Ukázky použití modifikačních funkcí a metod pracujících s indexy
############################################################################
mis = list('Mississipi');   mis
# ['M', 'i', 's', 's', 'i', 's', 's', 'i', 'p', 'i']
mis.index('s'),   mis.index('s', 4)
# (2, 5)
mis.index('p',0,6)
# Traceback (most recent call last):
#   File "<pyshell#388>", line 1, in <module>
#     mis.index('p',0,6)
# ValueError: 'p' is not in list
lp = list('Python');   lp[1]='a';   lp[3]='t';   lp
# ['P', 'a', 't', 't', 'o', 'n']
lp.insert(3, 'h');   lp
# ['P', 'a', 't', 'h', 't', 'o', 'n']
lp.pop(4),   lp.pop(),   lp
# ('t', 'n', ['P', 'a', 't', 'h', 'o'])
mis.remove('i');   mis
# ['M', 's', 's', 'i', 's', 's', 'i', 'p', 'i']
mis.remove('i');   mis
# ['M', 's', 's', 's', 's', 'i', 'p', 'i']
# >>>



#Výpis  12.11: Ukázky použití modifikačních metod pracujících s celým seznamem
############################################################################
lp = list('Python');   lp
# ['P', 'y', 't', 'h', 'o', 'n']
lp.reverse();   lp
# ['n', 'o', 'h', 't', 'y', 'P']
lp.sort();   lp
# ['P', 'h', 'n', 'o', 't', 'y']
lp.sort(reverse=True);   lp
# ['y', 't', 'o', 'n', 'h', 'P']
lp.sort(key=lambda char: ord(char) & 0x1F);   lp
# ['h', 'n', 'o', 'P', 't', 'y']
# >>>



#Výpis  12.12: Modul s metodami pracujícími s vícerozměrnými seznamy
############################################################################

""" Je uloženo v souboru m12_01_Pascal.py """



#Výpis  12.13: Načtení modulu m12_01_Pascal a prověření jeho funkce
############################################################################
from m12_01_Pascal import *
# ===== START načítání modulu m12_01_Pascal =====
# ===== KONEC načítání modulu m12_01_Pascal =====
print(printpas(pascal(6)))
#       1
#      1 1
#     1 2 1
#    1 3 3 1
#   1 4 6 4 1
#  1 5 10 10 5 1

# >>>

