# -*- coding: utf-8 -*-
#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/60_PGM/_SRC/m15_00_Slovníky.py
"""
Kopie pasáží se záznamy komunikace se systémem realizovanými v IDLE
a uvedenými ve výpisech kapitoly:  15  Slovníky.

Co se v kapitole naučíte
Tato kapitola vás nejprve seznámí s mapovacími objekty, aby se pak
soustředila na nejpoužívanější z nich – instance třídy dict neboli slovníky.
Naučí vás je vytvářet, využívat jejich generátorovou notaci
a představí vám základní operace pro práci se slovníky.
Na závěr vás ještě seznámí s pohledy a možnostmi jejich vyžití.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01_00_Startujeme.
"""



#Výpis 15.1: Vytváření slovníků pomocí literálů
############################################################################
d123 = {'Raz':1, 'Dva':2, 'Tři':3};   d123
# {'Raz': 1, 'Dva': 2, 'Tři': 3}
d132 = {'Raz':1, 'Tři':3, 'Dva':2};   d132
# {'Raz': 1, 'Tři': 3, 'Dva': 2}
d123 == d132
# True
import turtle
(dmix := {(1,2):'n-tice', min:'funkce', 3.14:'číslo', turtle:'modul'})
# {(1, 2): 'n-tice', <built-in function min>: 'funkce', 3.14: 'číslo', <module 'turtle' from 'Ca:\\_PGM\\Python\\Python38\\lib\\turtle.py'>: 'modul'}
d0 = {};   print(d0, type(d0))
# {} <class 'dict'>
org = {
    'Praha':{'vedoucí':'Petr',  'výkonný':'Pavel', 'pomocný':'Pepa'},
    'Brno' :{'vedoucí':'Bohouš','výkonný':'Bohdan','pomocný':'Bob'}}
# >>>



#Výpis 15.2: Vytváření slovníků pomocí funkce dict()
############################################################################
d213 = dict(Dva=2, Raz=1, Tři=3,);   d213
# {'Dva': 2, 'Raz': 1, 'Tři': 3}
d231 = dict([('Dva',2), ('Tři',3), ('Raz',1)]);   d231
# {'Dva': 2, 'Tři': 3, 'Raz': 1}
d312 = dict([('Tři',3), ('Raz',1)], Dva=2);   d312
# {'Tři': 3, 'Raz': 1, 'Dva': 2}
d321 = dict(zip(('Tři', 'Dva', 'Raz', 'Nic'), range(3, 0, -1)));   d321
# {'Tři': 3, 'Dva': 2, 'Raz': 1}
d123 == d132 == d213 == d231 == d312 == d321
# True
# >>>



#Výpis 15.3: Vytváření slovníků pomocí funkce fromkeys()
############################################################################
dict.fromkeys((list, tuple, set, frozenset, dict))
# {<class 'list'>: None, <class 'tuple'>: None, <class 'set'>: None, <class 'frozenset'>: None, <class 'dict'>: None}
dict.fromkeys(((0,0), (0,1), (1,0), (1,1)), 0)
# {(0, 0): 0, (0, 1): 0, (1, 0): 0, (1, 1): 0}
# >>>



#Výpis 15.4: Vytváření slovníků pomocí generátorové notace
############################################################################
{c : hex(ord(c)) for c in 'ABCD'}
# {'A': '0x41', 'B': '0x42', 'Ca': '0x43', 'D': '0x44'}
from utils import gen_fibonacci
(sf := {t for t in gen_fibonacci(7)}),   type(sf)
# ({(5, 8), (1, 1), (4, 5), (3, 3), (6, 13), (2, 2), (7, 21)}, <class 'set'>)
(df := {t[0] : t[1] for t in gen_fibonacci(7)}),   type(df)
# ({1: 1, 2: 2, 3: 3, 4: 5, 5: 8, 6: 13, 7: 21}, <class 'dict'>)
# >>>



#Výpis 15.5: Přístup k položkám prostřednictvím klíčů
############################################################################
empty = {}
empty[list]=[];  empty[tuple]=();  empty[set]=set();  empty[dict]={}
empty
# {<class 'list'>: [], <class 'tuple'>: (), <class 'set'>: set(), <class 'dict'>: {}}
def pre(object): print(object, to:=type(object), object==empty[to])

pre([]);   pre((1,));   pre(());   pre(1)
# [] <class 'list'> True
# (1,) <class 'tuple'> False
# () <class 'tuple'> True
# Traceback (most recent call last):
#   File "<pyshell#61>", line 1, in <module>
#     pre([]);   pre((1,));   pre(());   pre(1)
#   File "<pyshell#57>", line 1, in pre
#     def pre(object): print(object, to:=type(object), object==empty[to])
# KeyError: <class 'int'>
del empty[dict];   empty
# {<class 'list'>: [], <class 'tuple'>: (), <class 'set'>: set()}
# >>>



#Výpis 15.6: Metody pro práci s jednotlivými položkami
############################################################################
d = {'Nic':0, 'Raz':1, 'Dva':2, 'Tři':3};   d
# {'Nic': 0, 'Raz': 1, 'Dva': 2, 'Tři': 3}
d.get('Dva'),   d.get('Xxx', 'Chybí!'),   d.get('Xxx'),   d
# (2, 'Chybí!', None, {'Nic': 0, 'Raz': 1, 'Dva': 2, 'Tři': 3})
d.pop('Dva'),   d.pop('Xxx', 'Chybí!'),   d
# (2, 'Chybí!', {'Nic': 0, 'Raz': 1, 'Tři': 3})
d.popitem(),   d
# (('Tři', 3), {'Nic': 0, 'Raz': 1})
d.popitem(),   d
# (('Raz', 1), {'Nic': 0})
d.setdefault('Nic'),   d
# (0, {'Nic': 0})
d.setdefault('Dva', 2),   d
# (2, {'Nic': 0, 'Dva': 2})
d.setdefault('Tři'),   d
# (None, {'Nic': 0, 'Dva': 2, 'Tři': None})
# >>>



#Výpis 15.7: Použití metody update()
############################################################################
d;   d.update({'Raz': 1, 'Dva': 2, 'Tři': 3});   d
# {'Nic': 0, 'Dva': 2, 'Tři': None}
# {'Nic': 0, 'Dva': 2, 'Tři': 3, 'Raz': 1}
d.update(zip('AB', (10, 11)));   d
# {'Nic': 0, 'Dva': 2, 'Tři': 3, 'Raz': 1, 'A': 10, 'B': 11}
# >>>



#Výpis 15.8: Pohledy
############################################################################
d = dict(Raz=1, Dva=2, Tři=3,)
dk = d.keys();   dv = d.values();   di = d.items();   d; dk; dv; di;
# {'Raz': 1, 'Dva': 2, 'Tři': 3}
# dict_keys(['Raz', 'Dva', 'Tři'])
# dict_values([1, 2, 3])
# dict_items([('Raz', 1), ('Dva', 2), ('Tři', 3)])
d['Tři'] = 3.14;   d['Čty'] = 4;   d; dk; dv; di;
# {'Raz': 1, 'Dva': 2, 'Tři': 3.14, 'Čty': 4}
# dict_keys(['Raz', 'Dva', 'Tři', 'Čty'])
# dict_values([1, 2, 3.14, 4])
# dict_items([('Raz', 1), ('Dva', 2), ('Tři', 3.14), ('Čty', 4)])
# >>>



#Výpis 15.9: Pohledy jako generátory
############################################################################
for i in d: print(i, end='-')

# Raz-Dva-Tři-Čty-
for k, v in d.items(): print('<', k, ';', v, '>', sep='', end='-')

# <Raz;1>-<Dva;2>-<Tři;3.14>-<Čty;4>-
for k in d: print('<', k, ';', d[k], '>', sep='', end='-')

# <Raz;1>-<Dva;2>-<Tři;3.14>-<Čty;4>-
set(d.values())
# {1, 2, 3.14, 4}
list(d);   list(d.keys())
# ['Raz', 'Dva', 'Tři', 'Čty']
# ['Raz', 'Dva', 'Tři', 'Čty']
# >>>



#Výpis 15.10: Operace s pohledy
############################################################################
d = {'Raz':1, 'Dva':2, 'Tři':3};   d0 = {'Nic':0};   d4 = {'Čty':4};
{'Nic', 'Čty'}  |  d.keys()
# {'Čty', 'Tři', 'Raz', 'Nic', 'Dva'}
{'Nic', 'Čty'}  |  d.items()
# {'Čty', ('Tři', 3), 'Nic', ('Raz', 1), ('Dva', 2)}
{'Nic', 'Čty'}  |  d
# Traceback (most recent call last):
#   File "<pyshell#3>", line 1, in <module>
#     {'Nic', 'Čty'}  |  d
# TypeError: unsupported operand type(s) for |: 'set' and 'dict'
dks = d.keys()  |  d0;   (dks, type(dks))
# ({'Nic', 'Raz', 'Tři', 'Dva'}, <class 'set'>)
dks = d.keys()  |  d0  |  d4.keys();   (dks, type(dks))
# ({'Tři', 'Čty', 'Raz', 'Nic', 'Dva'}, <class 'set'>)
# >>>

