# -*- coding: utf-8 -*-
#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/60_PGM/_SRC/m16_00_Operace_se_stringy.py
"""
Kopie pasáží se záznamy komunikace se systémem realizovanými v IDLE
a uvedenými ve výpisech kapitoly:  17  Operace se stringy a formátování.

Co se v kapitole naučíte
Tato kapitola se vrací ke stringům a soustředí se především na problematiku
jejich formátování. Představí nejprve některé užitečné metody stringů
a poté ve stručnosti probere starší techniku formátování prostřednictvím
operátoru %. Poté se už soustředí na možnosti poskytované metodou format()
a na tzv. f stringy, které umožňují zadávat formátování prostřednictvím
stringových literálů.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01_00_Startujeme.
"""



#Výpis 17.1: Použití formátovacího operátoru
############################################################################
"%s hoří při %d stupních %s." % ("Papír", 451, "Fahrenheita")
# 'Papír hoří při 451 stupních Fahrenheita.'
'%*.*s = %.*f' % (6, 3, 'Prodloužení', 3, 2.7182)
# '   Pro = 2.718'
format = '%(název)s je %(typ)s %(konzument)s.'
format % {'název':'Ambrosie', 'typ':'pokrm', 'konzument':'bohů'}
# 'Ambrosie je pokrm bohů.'
format % dict(název='Nektar', typ='nápoj', konzument='bohů')
# 'Nektar je nápoj bohů.'
sada = ('název', 'typ', 'konzument')
format % dict(zip(sada, ('Pivo', 'tekutý chléb', 'Čechů')))
# 'Pivo je tekutý chléb Čechů.'
# >>>



#Výpis 17.2: Použití prázdné formátové položky
############################################################################
"První argument={}, druhý argument={}.".format("Jednička", "DVOJKA")
# 'První argument=Jednička, druhý argument=DVOJKA.'
'Použití závorek: {{ {} }}, {{{}}}'.format('Raz', 'Dva')
# 'Použití závorek: { Raz }, {Dva}'
# >>>



#Výpis 17.3: Použití neprázdných formátových položek a konverzí
############################################################################
'Nula: {2}, jedna: {0}, dva: {1}.'.format("Jednička", "DVOJKA", "Nic")
# 'Nula: Nic, jedna: Jednička, dva: DVOJKA.'
'Argumenty: ({Nic}, {0}, {1})'.format(1, 2, Nic=0)
# 'Argumenty: (0, 1, 2)'
'Jedna: {}, dva: {1}, Nula: {2}.'.format("Jednička", "DVOJKA", "Nic")
# Traceback (most recent call last):
#   File "<pyshell#64>", line 1, in <module>
#     'Jedna: {}, dva: {1}, Nula: {2}.'.format("Jednička", "DVOJKA", "Nic")
# ValueError: cannot switch from automatic field numbering to manual field specification
'ASCII: {0!a},  Repres: {0!r},  String: {0!s}'.format('Příklad')
# "ASCII: 'P\\u0159\\xedklad',  Repres: 'Příklad',  String: Příklad"
import m12_01_Pascal as pas
# ===== START načítání modulu m12_01_Pascal =====
# ===== KONEC načítání modulu m12_01_Pascal =====
lst = [pas, 11, 22, 33];   dct = {'d1':'Raz', 'd2':"Dva"}
'{0[2]} — {d2} — {0[0].pascal}'.format(lst, **dct)
# '22 — Dva — <function pascal at 0x000001246BF80790>'
# >>>



#Výpis 17.4: Zadání požadovaného minimálního počtu pozic
############################################################################
p = 'Python';   n=123;   from math import pi
'{0:4}|{0:8}|{1:2}|{1:3}|{1:4}|{2:4}'.format(p, n, pi)
# 'Python|Python  |123|123| 123|3.141592653589793'
'{0}|{0:5}|{0!s:1}|{1}|{1:5}|{1!a:5}|'.format(False, True)
# 'False|    0|False|True|    1|True |'
# >>>



#Výpis 17.5: Zadání požadované přesnosti, resp. maximálního počtu pozic
############################################################################
'{0:8.4}|{0:.4}|{1!s:.5}|{1!s:5.2}|'.format(p, True)
# 'Pyth    |Pyth|True|Tr   |'
for n in range(-2, 4):
    print('{0:2}: {1:8.3} —— {1:.4}'.format(n, pi * 10**n))

# -2:   0.0314 —— 0.03142
# -1:    0.314 —— 0.3142
#  0:     3.14 —— 3.142
#  1:     31.4 —— 31.42
#  2: 3.14e+02 —— 314.2
#  3: 3.14e+03 —— 3.142e+03
# >>>



#Výpis 17.6: Typy formátů pro celočíselné hodnoty
############################################################################
"{0:b} - {0:o} - {0:d} - {0:x} - {0:X} - '{0:c}'".format(0x263a)
# "10011000111010 - 23072 - 9786 - 263a - 263A - '☺'"
# >>>



#Výpis 17.7: Typy formátů pro zobrazení reálných čísel
############################################################################
for n in range(-4, 4):
    print("{0:2}: {1:8.3f} —— {1:8.3g} —— {1:8.3E} —— {1}"
          .format(n, pi * 10**n))

# -4:    0.000 —— 0.000314 —— 3.142E-04 —— 0.0003141592653589793
# -3:    0.003 ——  0.00314 —— 3.142E-03 —— 0.0031415926535897933
# -2:    0.031 ——   0.0314 —— 3.142E-02 —— 0.031415926535897934
# -1:    0.314 ——    0.314 —— 3.142E-01 —— 0.3141592653589793
#  0:    3.142 ——     3.14 —— 3.142E+00 —— 3.141592653589793
#  1:   31.416 ——     31.4 —— 3.142E+01 —— 31.41592653589793
#  2:  314.159 ——      314 —— 3.142E+02 —— 314.1592653589793
#  3: 3141.593 —— 3.14e+03 —— 3.142E+03 —— 3141.592653589793
'{:_f}'.format(12_345_678_901_234_567_890_123_456_789.)
# '12_345_678_901_234_568_227_576_610_816.000000'
'{0:.2f} —— {0:.1e}'.format(1+2j)
# '1.00+2.00j —— 1.0e+00+2.0e+00j'
# >>>



#Výpis 17.8: Zadání oddělovačů skupin číslic a alternativního formátu
############################################################################
'{0:,d}, {0:_d}, {0:_b}, {0:_o}, {0:_x}, {0:_X}'.format(76_543)
# '76,543, 76_543, 1_0010_1010_1111_1111, 22_5377, 1_2aff, 1_2AFF'
'{0:#_d}, {0:#_b}, {0:#_o}, {0:#_x}, {0:#_X}'.format(76_543)
# '76_543, 0b1_0010_1010_1111_1111, 0o22_5377, 0x1_2aff, 0X1_2AFF'
'{0:_f}, {0:_}, {0:_g}'.format(1234.56789)
# '1_234.567890, 1_234.56789, 1_234.57'
'{0:.0f}, {0:#.0f}, {0:.0}, {0:#.0}, {0:.1g}, {0:#.1g}'.format(1.5)
# '2, 2., 2e+00, 2.e+00, 2, 2.'
'{0:.2f}, {0:#.2f}, {0:.2e}, {0:#.2e}, {0:.3g}, {0:#.3g}'.format(1)
# '1.00, 1.00, 1.00e+00, 1.00e+00, 1, 1.00'
'{0:.2}'.format(1)
# Traceback (most recent call last):
#   File "<pyshell#59>", line 1, in <module>
#     '{0:.2}'.format(1)
# ValueError: Precision not allowed in integer format specifier
# >>>



#Výpis 17.9: Zarovnání a plnění
############################################################################
'{p:10}|{n:10}|{n!s:10}|{pi:10.3}|'.format(p=p, n=n, pi=pi)
# 'Python    |       123|123       |      3.14|'
'{0:\x3d<10}|{0:.^10}|{0:>>10}'.format(p)
# 'Python====|..Python..|>>>>Python'
'{n:>7}|{n:0>7}|{n:0>+7}|{n:0> 7}|{nn:0> 7}|'.format(n=n, nn=-n); \
'{n:=7}|{n:0=7}|{n:0=+7}|{n:0= 7}|{nn:0= 7}|'.format(n=n, nn=-n); \
 '{n:7}|{n:=07}|{n:=+07}|{n:= 07}|{nn:= 07}|'.format(n=n, nn=-n)
# '    123|0000123|000+123|000 123|000-123|'
# '    123|0000123|+000123| 000123|-000123|'
# '    123|0000123|+000123| 000123|-000123|'
# >>>



#Výpis 17.10: Používání vnořených nahrazovacích polí
############################################################################
'{0:{1}>10}|{0:.^10}|{0:{2}<10}'.format(p, '{', '}')
# '{{{{Python|..Python..|Python}}}}'
for a in range(3, 10, 3):  '{:.{}f}'.format(pi, a)

# '3.142'
# '3.141593'
# '3.141592654'
# >>>



############################################################################
#Kap 17.5  Stringová interpolace – f stringy
############################################################################
f'{pi:.2f}**2 = {pi**2:.2f}'
# '3.14**2 = 9.87'

theme ='jídlo';   subject = 'svíčková'
(fs := f'Nejoblíbenější {theme} je {subject}.')
# 'Nejoblíbenější jídlo je svíčková.'
theme ='herec';   subject = 'Chuck Norris';   fs
# 'Nejoblíbenější jídlo je svíčková.'

#!# f"Kód odřádkování = {ord('\n')}"
# SyntaxError: f-string expression part cannot include a backslash
lf='\n';   f"Kód odřádkování = {ord(lf)}"
# 'Kód odřádkování = 10'

přesnost=6;   f"π ={pi:{ přesnost+2}.{přesnost}}"
# 'π = 3.14159'

f"""Výsledek je {round(pi * pi) + pi
                :.{přesnost}}"""
# 'Výsledek je 13.1416'

f"Kontrola: {round(pi * pi) + pi =:{přesnost+2}.{přesnost}}"
# 'Kontrola: round(pi * pi) + pi =  13.1416'

f'{pi:.2f}'  +  f'^2 = '  +  f'{pi*pi:.2f}'; \
f'{pi:.2f}'  +   '^2 = '  +  f'{pi*pi:.2f}'; \
f'{pi:.2f}'  +   '^2 = '  +   '{pi*pi:.2f}'
# '3.14^2 = 9.87'
# '3.14^2 = 9.87'
# '3.14^2 = {pi*pi:.2f}'



#Výpis 17.11: Definice funkce printpasf() v modulu m17_01_PrintPasF
############################################################################

##### Definice je v modulu m17_01_PrintPasF



#Výpis 17.12: Použití funkce printpasf() v modulu m17_01_PrintPasF
############################################################################
from m12_01_Pascal    import *
from m17_01_PrintPasF import *
# ===== START načítání modulu m17_01_PrintPasF =====
# ===== KONEC načítání modulu m17_01_PrintPasF =====
print(printpasf(pascal(10)))
#                    1
#                  1   1
#                1   2   1
#              1   3   3   1
#            1   4   6   4   1
#          1   5   10  10  5   1
#        1   6   15  20  15  6   1
#      1   7   21  35  35  21  7   1
#    1   8   28  56  70  56  28  8   1
#  1   9   36  84 126 126  84  36  9   1

# >>>



#Výpis 17.13: Trasovací funkce prBE() v modulu utils
############################################################################
def prBE(fce, sk, msg=''):
    """Vytiskne oznámení o startu, resp. konci provádění volající funkce.
       fce = funkce volající tuto funkci
       sk = příznak tisku startu (True) či ukončení (False) těla funkce
       msg = Případná zpráva za vlastním oznámením
    """
    if not sk: prBE.level -= 1  # Trasovaná metoda končí, zmenšuji odsazení
    print(f'{prBE.level*prBE.sp}{fce.__name__} - ' +
          f'{"START" if sk else "KONEC"}' +
          f'{"" if msg == "" else f" - {msg}"}')
    if sk: prBE.level += 1  # Zvětšuji odsazení pro nižší hladinu
prBE.level = 0     # Hladina vnoření pro nastavení odsazení
prBE.sp = '  '     # Text odsazení pro znázornění hladiny volání

