# -*- coding: utf-8 -*-
#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ ó
#P:/60_PGM/_SRC/m19_00_Práce_se_soubory.py
"""
Kopie pasáží se záznamy komunikace se systémem realizovanými v IDLE
a uvedenými ve výpisech kapitoly:  19  Práce se soubory.

Co se v kapitole naučíte
Pod prací se soubory si jednou představíme práci se souborovým systémem
(tj. vytváření, vyhledávání, přejmenování a mazání souborů a složek),
podruhé práci s vlastními soubory (tj. jejich čtení a zapisování).
Tato kapitola vás seznámí s možnostmi Pythonu v obou zmíněných oblastech.
Ve výkladu se přitom omezí na operační systémy běžně rozšířené mezi
uživateli – Windows, macOS, Android a Linux.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01_00_Startujeme.
"""



#Výpis 19.1: Zjištění a změna aktuální složky
############################################################################
import os
os.getcwd()     # get current working directory
# 'P:\\60_PGM\\_SRC'
os.chdir('..')  # change directory
os.getcwd()
# 'P:\\60_PGM'
os.chdir('_SRC');   (cwd:=os.getcwd());   print(cwd)
# 'P:\\60_PGM\\_SRC'
# P:\60_PGM\_SRC
os.listdir('..')
# ['60_Python_NB', '60_Python_PyCharm', 'Grammar for Python 3.8_β2.py', 'INSTALL_PGM_Python.lnk', 'Mod', '_AUX', '_HLP', '_LST', '_REC', '_SRC']
os.listdir('DATA')
# []
# >>>



#Výpis 19.2: Syntéza a analýza cest
############################################################################
data = os.path.join(cwd, 'DATA', 'data.txt');   data
# 'P:\\60_PGM\\_SRC\\DATA\\data.txt'
os.path.join(cwd, 'výplň', data);   os.path.join(data, cwd, 'výplň')
# 'P:\\60_PGM\\_SRC\\DATA\\data.txt'
# 'P:\\60_PGM\\_SRC\\výplň'
os.path.join(data, cwd, '/výplň')
# 'P:/výplň'
(dn := os.path.dirname(data)),   (bn := os.path.basename(data)); \
os.path.split(data);   os.path.splitext(data)
# ('P:\\60_PGM\\_SRC\\DATA', 'data.txt')
# ('P:\\60_PGM\\_SRC\\DATA', 'data.txt')
# ('P:\\60_PGM\\_SRC\\DATA\\data', '.txt')
os.path.split(dn);   os.path.split(bn);   os.path.splitext(dn)
# ('P:\\60_PGM\\_SRC', 'DATA')
# ('', 'data.txt')
# ('P:\\60_PGM\\_SRC\\DATA', '')
os.path.abspath('.');   os.path.relpath(data)
# 'P:\\60_PGM\\_SRC'
# 'DATA\\data.txt'
# >>>



#Výpis 19.3: Získání informací o souborech
############################################################################
dn, data;   os.path.exists(dn),   os.path.exists(data)
# ('P:\\60_PGM\\_SRC\\DATA', 'P:\\60_PGM\\_SRC\\DATA\\data.txt')
# (True, False)
os.path.getsize('..'),   os.path.getsize('.'),   os.path.getsize('DATA')
# (4096, 8192, 0)
m07 = 'm07_01_Modul.py';   os.path.getsize(m07)
# 1322
os.path.isdir('.'),   os.path.isfile('.')
# (True, False)
os.path.isdir(m07),   os.path.isfile(m07)
# (False, True)
os.path.isdir(data),   os.path.isfile(data)
# (False, False)
# >>>



#Výpis 19.4: Vytváření a mazání složek
############################################################################
os.mkdir((tmp := '../TMP'))
os.mkdir(tmp)
# Traceback (most recent call last):
#   File "<pyshell#51>", line 1, in <module>
#     os.mkdir(tmp)
# FileExistsError: [WinError 183] Nelze vytvořit soubor, který již existuje: '../TMP'
aaa = os.path.join(tmp, 'a/aa/aaa');   aaa
# '../TMP\\a/aa/aaa'
aaa = os.path.normpath(aaa);   aaa
# '..\\TMP\\a\\aa\\aaa'
os.mkdir(aaa)
# Traceback (most recent call last):
#   File "<pyshell#53>", line 1, in <module>
#     os.mkdir(aaa)
# FileNotFoundError: [WinError 3] Systém nemůže nalézt uvedenou cestu: '../TMP\\a/aa/aaa'
os.makedirs(aaa);   os.path.exists(aaa)
# True
# >>>



#Výpis 19.5: Otevření souboru
############################################################################
data, (win:=os.path.join(aaa, 'win.txt'))
# ('P:\\60_PGM\\_SRC\\DATA\\data.txt', '..\\TMP\\a\\aa\\aaa\\win.txt')
os.path.exists(data),   os.path.exists(win)
# (False, False)
fw = open(win, 'w');   os.path.exists(win),   fw
# (True, <_io.TextIOWrapper name='..\\TMP\\a\\aa\\aaa\\win.txt' mode='w' encoding='cp1250'>)
fd = open(data, 'w', 1, 'utf8');   os.path.exists(data),   fd
# (True, <_io.TextIOWrapper name='P:\\60_PGM\\_SRC\\DATA\\data.txt' mode='w' encoding='utf8'>)
# >>>



#Výpis 19.6: Zápis dat, splachování a zavírání souborů
############################################################################
pangram = 'Příliš žluťoučký kůň úpěl ďábelské ó.'
print(pangram, file=fd);   print(pangram, file=fw)
fw.flush()
print(pangram, file=fd);   print(pangram, file=fw, flush=True)
text = 'Copyright-©, Alpha-α, Beta-β, Smile-☺'
print(text, file=fd)
print(text, file=fw)
# Traceback (most recent call last):
#   File "<pyshell#29>", line 1, in <module>
#     print(text, file=fw)
#   File "Ca:\_PGM\Python\Python38\lib\encodings\cp1250.py", line 19, in encode
#     return codecs.charmap_encode(input,self.errors,encoding_table)[0]
# UnicodeEncodeError: 'charmap' codec can't encode character '\u03b1' in position 19: character maps to <undefined>
fd.close();   fw.close()
# >>>



#Výpis 19.7: Čtení souborů
############################################################################
fd = open(data, 'r', 1, 'utf8')
while (line:=fd.readline()) != '':
    print(repr(line))

# 'Příliš žluťoučký kůň úpěl ďábelské ó.\n'
# 'Příliš žluťoučký kůň úpěl ďábelské ó.\n'
# '\n'
# 'Copyright-©, Alpha-α, Beta-β, Smile-☺\n'
fd.close()
fw = open(win)
while (line:=fw.read(59)) != '':
    print(repr(line))

# 'Příliš žluťoučký kůň úpěl ďábelské ó.\nPříliš žluťoučký kůň '
# 'úpěl ďábelské ó.\n\n'
fw.close()
fd = open(data, 'r', 1, 'utf8')
fd.readlines()
# ['Příliš žluťoučký kůň úpěl ďábelské ó.\n', 'Příliš žluťoučký kůň úpěl ďábelské ó.\n', '\n', 'Copyright-©, Alpha-α, Beta-β, Smile-☺\n']
fd.seek(0)   # Přesune aktuální pozici zpět na začátek souboru
# 0
for line in fd:
    print(repr(line[:10]), end=' === ')

# 'Příliš žlu' === 'Příliš žlu' === '\n' === 'Copyright-' ===
fd.close()
# >>>

