# -*- coding: utf-8 -*-
#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/60_PGM/_SRC/m22_00_Dědění.py
"""
Kopie pasáží se záznamy komunikace se systémem realizovanými v IDLE
a uvedenými ve výpisech kapitoly:  22  Jednoduché dědění.

Co se v kapitole naučíte
Teoretické základy dědění jsme probrali v podkapitole 20.8  Dědění
na straně 344. Tato kapitola vás naučí jednoduché dědění v Pythonu zadávat
a vysvětlí vám, jaká pravidla se při jeho používání uplatňují.
Na závěr vám představí zabudované funkce pracující s objekty.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01_00_Startujeme.
"""



#Výpis 22.1: Definice tříd LA, LB a LC v modulu m22_01_L1ABC
############################################################################

# Definice se nacházejí v modulu m22_01_L1ABC



#Výpis 22.2: Analýza tříd z modulu m22_01_L1ABC a jejich instancí
############################################################################
from m22_01_LABC import *
a1 = LA(1);   b1 = LB(1);   c1 = LC(1);   a1, b1, c1
# (LA_1, LB_1, LC_1)
a1.__dict__;   b1.__dict__;   c1.__dict__
# {'ID': 1, 'iX': 'LA_isp', 'iA': 'LA_ins'}
# {'ID': 1, 'iX': 'LB_isp', 'iA': 'LA_ins', 'iB': 'LB_ins'}
# {'ID': 1, 'iX': 'LC_isp', 'iA': 'LA_ins', 'iB': 'LB_ins', 'iC': 'LC_ins'}
from utils import prdict
prdict(LA);   prdict(LB);   prdict(LC)
# ##### Atributy objektu <class 'm22_01_LABC.LA'>
# cX = 1A_csp
# cA = LA_cls
# mtdA = <function LA.mtdA at 0x00000188310DDF70>
# mtdv = <function LA.mtdv at 0x0000018831105040>
# ##### Atributy objektu <class 'm22_01_LABC.LB'>
# cX = 1B_csp
# cB = LB_cls
# mtdB = <function LB.mtdB at 0x0000018831105160>
# mtdv = <function LB.mtdv at 0x00000188311051F0>
# ##### Atributy objektu <class 'm22_01_LABC.LC'>
# cX = LC_csp
# cC = LC_cls
# mtdC = <function LC.mtdC at 0x0000018831105310>
# mtdv = <function LC.mtdv at 0x00000188311053A0>
# >>>



#Výpis 22.3: Používání třídních atributů v hierarchii dědění
############################################################################
LC.cA,   LC.cB,   LC.cC,   LC.cX,   LB.cX,   LA.cX
# ('LA_cls', 'LB_cls', 'LC_cls', 'LC_csp', '1B_csp', '1A_csp')
c1.cA,   c1.cB,   c1.cC,   c1.cX
# ('LA_cls', 'LB_cls', 'LC_cls', 'LC_csp')
# >>>



#Výpis 22.4: Volání metod v hierarchii dědění
############################################################################
a1.mtdA(),; \
b1.mtdA(),   b1.mtdB(); \
c1.mtdA(),   c1.mtdB(),   c1.mtdC()
# ('LA_inst(LA_1)',)
# ('LA_inst(LB_1)', 'LB_inst(LB_1)')
# ('LA_inst(LC_1)', 'LB_inst(LC_1)', 'LC_inst(LC_1)')
a1.mtdv(),; \
b1.mtdv(), LA.mtdv(b1); \
c1.mtdv(), LA.mtdv(c1), LB.mtdv(c1)
# ('LA_virt(LA_1)',)
# ('LB_virt(LB_1)', 'LA_virt(LB_1)')
# ('LC_virt(LC_1)', 'LA_virt(LC_1)', 'LB_virt(LC_1)')
# >>>



#Výpis 22.5: Demonstrace dědění konstruktorů
############################################################################
class Matka22:
    def __init__(self, a, b, c): self.t = (a, b, c)
    def __repr__(self): return f"{self.__class__.__name__}{self.t}"

class Dcera22(Matka22): pass

Matka22(1, 2, 3),   Dcera22(10, 20, 30)
# (Matka22(1, 2, 3), Dcera22(10, 20, 30))
Dcera22()
# Traceback (most recent call last):
#   File "<pyshell#80>", line 1, in <module>
#     Dcera22()
# TypeError: __init__() missing 3 required positional arguments: 'a', 'b', and 'c'
# >>>



#Výpis 22.6: Ukázka definice a použití vlastní výjimky
############################################################################
# >>> \
class RobotError(Exception):
    """Výjimka vyhazovaná při uvedení robota do chybového stavu.

    Atributy:
        robot -- Robot, který se dostal do chybového stavu
        message -- Popis chybového stavu
    """

    def __init__(self, robot, message):
        self.robot   = robot
        self.message = message

raise RobotError('Karel_1', 'Robot narazil do zdi')
# Traceback (most recent call last):
#   File "<pyshell#25>", line 1, in <module>
#     raise RobotError('Karel_1', 'Robot narazil do zdi')
# RobotError: ('Karel_1', 'Robot narazil do zdi')
# >>>



##### Kapitola 22.10: Zabudované funkce pracující s objekty
############################################################################

# map(function, iterable, …)
#---------------------------------------------------------------------------
for x in map(lambda a, b, c: a + b + c,
             (1,2,3,4), (10,20,30), (200,300,400)):
    print(x, end=' - ')

# 211 - 322 - 433 -
# >>>



############################################################################
##### KONEC #####
