# -*- coding: utf-8 -*-
#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/60_PGM/_SRC/m00_00_Šablona_kapitoly.py
"""
Kopie pasáží se záznamy komunikace se systémem realizovanými v IDLE
a uvedenými ve výpisech kapitoly:  23  Násobné dědění

Co se v kapitole naučíte
Tato kapitola vám vysvětlí, jak v Pythonu využívat násobné dědění a
jaká pravidla při jeho používání platí. Soustředí se přitom především
na pravidla vyhledání deklarovaného atributu v hierarchii předků.
Probere komolení jmen a na závěr představí návrhový vzor Šablonová metoda
a předvede jeho implementaci.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01_00_Startujeme.
"""



#Výpis 23.1: Zdrojový kód pomocné funkce prsk() z modulu utils informující
#            o startu a konci provádění těla metody, v níž je použita
############################################################################
def prSK(self, cls, sk, msg=''):
    """Vytiskne oznámení o startu, resp, konci provádění volající metody.
       cls = třída, jejíž metoda tuto metodu volá
       sk  = příznak tisku startu (True) či ukončení (False) těla metody
       msg = případná zpráva za vlastním oznámením
    """
    if not sk: prSK.level -= 1  # Trasovaná metoda končí, zmenšuji odsazení
    print(f'{prSK.level * prSK.sp}{cls.__name__} - ' +
          f'{"START" if sk else "KONEC"}' +
          f'{"" if msg == "" else f" - {msg}"}')
    if sk: prSK.level += 1  # Zvětšuji odsazení pro nižší hladinu
prSK.level = 0      # Hladina vnoření pro nastavení odsazení
prSK.sp = '   '     # Text odsazení pro znázornění hladiny volání



#Výpis 23.2: Zdrojový kód tříd z modulu m23_01_Diamant demonstrujících chování
#            diamantové architektury
############################################################################

""" Je uloženo v souboru m23_01_Diamant.py. """



#Výpis 23.3: Prověrka vlastností násobného dědění
############################################################################
from m23_01_Diamant import *
from utils import *
prseq(Dcera.__mro__)
# <class 'm23_01_Diamant.Dcera'>
# <class 'm23_01_Diamant.Matka1'>
# <class 'm23_01_Diamant.Matka2'>
# <class 'm23_01_Diamant.Babička'>
# <class 'object'>
d = Dcera()
# Dcera - START
#    Matka1 - START
#       Matka2 - START
#          Babička - START
#          Babička - KONEC - 1
#       Matka2 - KONEC - 1
#    Matka1 - KONEC - 1
# Dcera - KONEC - 1
d.__dict__
# {'ID': 1, 'iB': 'insBab', 'iM': 'insMa1', 'iD': 'insDcA'}
d.cM,   Dcera.cM,   Matka1.cM,   Matka2.cM
# ('clsMa1', 'clsMa1', 'clsMa1', 'clsMa2')
# >>>



#Výpis 23.4: Definice třídy DceraB v modulu m23_01_Diamant
############################################################################

""" Je uloženo v souboru m23_01_Diamant.py. """



#Výpis 23.5: Použití třídy DceraB
############################################################################
dB = DceraB()
# DceraB - START
#    Matka1 - START
#       Matka2 - START
#          Babička - START
#          Babička - KONEC - 2
#       Matka2 - KONEC - 2
#    Matka1 - KONEC - 2
#    Matka2 - START
#       Babička - START
#       Babička - KONEC - 3
#    Matka2 - KONEC - 3
# DceraB - KONEC - 3
dB.__dict__
# {'ID': 3, 'iB': 'insBab', 'iM': 'insMa2', 'iD': 'insDcB'}
dB.cM,   DceraB.cM
# ('clsMa1', 'clsMa1')
# >>>



#Výpis 23.6: Nerealizovatelná a následně opravená hierarchie tříd
############################################################################
Ba1 = type('BabičkaA1', (),         {})
Ba2 = type('BabičkaA2', (),         {})
Ma1 = type('MatkaA1',   (Ba1, Ba2), {})
Ma2 = type('MatkaA2',   (Ba2, Ba1), {})
Da1 = type('DceraA1',   (Ma1, Ma2), {})
# Traceback (most recent call last):
#   File "<pyshell#91>", line 1, in <module>
#     Da1 = type('DceraA1',   (Ma1, Ma2), {})
# TypeError: Cannot create a consistent method resolution
# order (MRO) for bases BabičkaA1, BabičkaA2
Ma2 = type('MatkaA2',   (Ba1, Ba2), {})
Da1 = type('DceraA1',   (Ma1, Ma2), {})
prseq(Da1.__mro__)
# <class '__main__.DceraA1'>
# <class '__main__.MatkaA1'>
# <class '__main__.MatkaA2'>
# <class '__main__.BabičkaA1'>
# <class '__main__.BabičkaA2'>
# <class 'object'>
# >>>



#Výpis 23.7: Složitější hierarchie tříd
############################################################################
Bb1 = type('BabičkaB1', (),         {})
Bb2 = type('BabičkaB2', (),         {})
Bb3 = type('BabičkaB3', (),         {})
Mb1 = type('MatkaB1',   (Bb1, Bb2), {})
Mb2 = type('MatkaB2',   (Bb2, Bb3), {})
Db1 = type('DceraB1',   (Mb1, Mb2), {})
prseq(Db1.__mro__)
# <class '__main__.DceraB1'>
# <class '__main__.MatkaB1'>
# <class '__main__.BabičkaB1'>
# <class '__main__.MatkaB2'>
# <class '__main__.BabičkaB2'>
# <class '__main__.BabičkaB3'>
# <class 'object'>
# >>>



#Výpis 23.8: Pseudosoukromý atribut a komolení jmen
############################################################################
class Pseudo:
    __atr = 'Pseudoprivate'
    def pr1(): print(__atr)
    def pr2(): print(Pseudo.__atr)

prdict(Pseudo)
# ##### Atributy objektu:
# _Pseudo__atr = Pseudoprivate
# pr1 = <function Pseudo.pr1 at 0x000001FCFF00B9D0>
# pr2 = <function Pseudo.pr2 at 0x000001FCFE7FBAF0>
# >>>



#Výpis 23.9: Definice tříd Bd a Md v modulu m23_02_Komolení
############################################################################

""" Je uloženo v souboru m23_02_Komolení.py. """



#Výpis 23.10: Použití tříd Bd a Md a jejich instancí
############################################################################
from m23_02_Komolení import *
bd = Bd();   md = Md();   bd, md
# (Bd_1, Md_2)
md.tmpl()
# Priv v Bd pro Md_2:
# self.__cpa='pr cls Bd', self.cpub='pu cls Md'
# self.__ipa='pr ins Bd', self.ipub='pu ins Md'
# Publ v Md pro Md_2:
# self.__cpa='pr cls Md', self.cpub='pu cls Md'
# self.__ipa='pr ins Md', self.ipub='pu ins Md'
Bd._Bd__count = 10
bd = Bd();   md = Md();   bd, md
# (Bd_11, Md_12)
# >>>



############################################################################
##### KONEC #####
