#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/60_PGM/_SRC/m024_01_Zlomek.py
"""
Instance třídy Zlomek reprezentují zlomky, které se umějí podepsat
a které je možné sčítat a násobit.
"""

# print('===== START načítání modulu', __name__, '=====')



#Výpis 24.1: Definice třídy Zlomek v modulu m24_01_Zlomek
############################################################################
class Zlomek:
    """Zjednodušená verze třídy, jejíž instance reprezentují zlomky."""

    def __init__(self, čitatel:int, jmenovatel:int=1):
        """Vytvořený zlomek bude už zkrácený (tj. s nejmenším čitatelem
           a jmenovatelem) a bude mít kladného jmenovatele."""
        if jmenovatel < 0:
            čitatel    = -čitatel
            jmenovatel = -jmenovatel
        from math import gcd  # Největší společný dělitel
        nsd = gcd(čitatel, jmenovatel)
        self.čitatel    = čitatel    // nsd
        self.jmenovatel = jmenovatel // nsd

    def __format__(self, format_spec):
        """Je-li čitatel > jmenovatel, vypíše zvlášť celou část.
           Formátovací specifikace zatím ignoruje."""
        podíl, zbytek = divmod(self.čitatel, self.jmenovatel)
        txt =  f"({podíl if podíl!=0 else ''}"            + \
               f"{'+' if podíl!=0 and zbytek!=0 else ''}" + \
               f"{f'{zbytek}/{self.jmenovatel}'if zbytek!=0 else ''})"
        return f"{txt:{format_spec}}"

    def __repr__(self):   return 'Zlomek' + self.__format__('')
    def __str__ (self):   return            self.__format__('') + 'Zlomek'

    def __add__(self, other):
        if isinstance(other, int):
            return Zlomek(self.čitatel + self.jmenovatel*other,
                          self.jmenovatel)
        elif isinstance(other, Zlomek):
            return Zlomek(self.čitatel * other.jmenovatel +
                          self.jmenovatel * other.čitatel,
                          self.jmenovatel * other.jmenovatel)
        else:
            raise TypeError("Přičítat je možné pouze celá čísla a zlomky")

    def __mul__(self, other):
        if isinstance(other, int):
            return Zlomek(self.čitatel * other, self.jmenovatel)
        elif isinstance(other, Zlomek):
            return Zlomek(self.čitatel    * other.čitatel,
                          self.jmenovatel * other.jmenovatel)
        else:
            raise TypeError("Přičítat je možné pouze celá čísla a zlomky")

    def __radd__(self, other): return self.__add__(other)

    def __rmul__(self, other): return self.__mul__(other)


# print('===== KONEC načítání modulu', __name__, '=====')
