# -*- coding: utf-8 -*-
#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/60_PGM/_SRC/m24_02_Atributy.py
"""
Definice demonstračních tříd k výkladu přetěžování operátorů.
"""

# print('===== START načítání modulu', __name__, '=====')



#Výpis 24.5: Definice třídy C24a v modulu m24_02_Atributy
############################################################################
class C24a:
    """AHA-příklad s demonstracemi přístupových metod k atributům."""
    ca = 'Class attr'

    def __init__(self):
        self.ia = 'Inst attr'

    def __getattribute__(self, name):
        """Metoda spouštěná při každém čtecím přístupu k atributu."""
        print(f"__getattribute__(self, {name=})")
        if name == 'ib' :
            return 'ib - Spočtený v _getattribute__()'
        elif name[0] == 'c':
            print(f"{name} - atributy začínající 'c' jsou třídní =>\n"
                  f"     Volám C24a.__getattribute__(C24a, {name})")
            return type.__getattribute__(C24a, name)
        else:
            print(f"Spouštím: object.__getattribute__(self, {name=})")
            return object.__getattribute__(self, name)
            # return self.name

    def __getattr__(self, name):
        """Metoda spouštěná, když _getattribute__() selže."""
        print(f"__getattr__(self, {name=})")
        return name + ' - Spočtený v _getattr__()'

    def __setattr__(self, name, value):
        """Metoda spouštěná při zapisovacím přístupu k atributu."""
        print(f"__setattr__(self, {name=}, {value=})")
        self.__dict__[name] = value

    def mtd(self):   print('mtd - Instanční metoda třídy C24a')



#Výpis 24.7: Definice třídy C24b v modulu m24_02_Atributy
############################################################################
class C24b:
    """Výhodnější řešení nestandardního přístupu k atributům."""

    def __getattr__(self, name):
        print(f"__getattr__(self, {name=})")
        return self.ia[-1:]  if name=='ID' else \
              f'Neexistující atribut: {name}'

    def __setattr__(self, name, value):
        print(f"__setattr__(self, {name=}, {value=})")
        if name in self.__dict__:
            raise ValueError("Hodnotu konstanty nelze měnit")
        self.__dict__[name] = value

    def __delattr__(self, name):
        if name in self.__dict__:
            raise ValueError(f"Konstantu {name} nelze smazat")
        raise AttributeError(f"Instance třídy {self.__class__.__name__} "
                           + f"nemají atribut '{name}'")


# print('===== KONEC načítání modulu', __name__, '=====')
