# -*- coding: utf-8 -*-
#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/60_PGM/_SRC/m25_00_Dekorátory.py
"""
Kopie pasáží se záznamy komunikace se systémem realizovanými v IDLE
a uvedenými ve výpisech kapitoly:  25  Dekorátory.

Co se v kapitole naučíte
Kapitola vás seznámí s dekorátory, naučí vás používat existující dekorátory
a poté také definovat dekorátory vlastní.
Předvede rozdíly mezi dekorováním funkcí a tříd
a na závěr ještě stručně probere některé speciální možnosti.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01_00_Startujeme.
"""



#Výpis 25.1: Definice třídy C25a a jejích metod využívajících dekorátorů
############################################################################
# >>> \
class C25a:
    """Demonstrace použití dekorátorů."""

    def inst(self): return f"{self.__class__.__name__}[{id(self):#_x}]"

    def class0(cls): return f"Metoda třídy {cls.__name__} - PO"
    class0 = classmethod(class0)

    @classmethod
    def class1(cls): return f"Metoda třídy {cls.__name__} - PŘED"

    def static0(): return 'Statická - PO'
    static0 = staticmethod(static0)

    @staticmethod
    def static1(): return 'Statická - PŘED'

c = C25a();   C25a.inst(c),   c.inst()
# ('C25a[0x182_c0c5_9850]', 'C25a[0x182_c0c5_9850]')
C25a().class0(),    c.class0()
# ('Metoda třídy C25a - PO', 'Metoda třídy C25a - PO')
C25a().class1(),    c.class1()
# ('Metoda třídy C25a - PŘED', 'Metoda třídy C25a - PŘED')
C25a().static0(),   c.static0()
# ('Statická - PO', 'Statická - PO')
C25a().static1(),   c.static1()
# ('Statická - PŘED', 'Statická - PŘED')
# >>>



#Výpis 25.2: Ukázka použití třídních metod
############################################################################
# >>> \
class Matka25a0:
    počet = 0
    @classmethod
    def další(cls):   cls.počet += 1;   return cls.počet
    def __init__(self):   self.ID=self.další()
    def __repr__(self):   return f"{self.__class__.__name__}({self.ID})"

# >>> \
class Dcera25a1(Matka25a0):   # Přebíjí rodičovský konstruktor
    počet = 0
    def __init__(self):   Matka25a0.__init__(self)

# >>> \
class Dcera25a2(Matka25a0):   # Zdědí rodičovský konstruktor
    počet = 0

Matka25a0(), Matka25a0(), Matka25a0()
# (Matka25a0(1), Matka25a0(2), Matka25a0(3))
Dcera25a1(), Dcera25a1(), Dcera25a1()
# (Dcera25a1(1), Dcera25a1(2), Dcera25a1(3))
Dcera25a2(), Dcera25a2(), Dcera25a2()
# (Dcera25a2(1), Dcera25a2(2), Dcera25a2(3))
# >>>



#Výpis 25.3: Definice dekorátoru – třídy traced v modulu m25_01_Traced
############################################################################

""" Je uloženo v souboru m25_01_Traced.py. """



#Výpis 25.4: Použití dekorátoru traced
############################################################################
from m25_01_Traced import traced
@traced
def test(n):
    import utils
    utils.factR = traced(utils.factR)
    utils.factR(n)

test(3)
# >> test((3,))
#    >> factR((3,))
#       >> factR((2,))
#          >> factR((1,))
#          << factR=1
#       << factR=2
#    << factR=6
# << test=None
test(1)
# >> test((1,))
# fce=<m25_01_Traced.traced object at 0x00000229FF81BA60>
#    >> factR((1,))
#    << factR=1
# << test=None
test
# <m25_01_Traced.traced object at 0x00000229FF7CA130>
# >>>



#Výpis 25.5: Definice dekorátorů jedináčka v modulu m25_02_Singleton
############################################################################

""" Je uloženo v souboru m25_02_Singleton.py. """



#Výpis 25.6: Použití dekorátoru singleton
############################################################################
from m25_02_Singleton import *
# >>> \
@singleton
class STest:
    count = 0
    def __init__(self):
        # STest.count+=1
        # self.ID=f'STest_{STest.count}'
        self.__class__.count += 1
        self.ID = f'STest_{self.__class__.count}'
    def __repr__(self):   return self.ID

STest(), STest(), STest()
# (STest_1, STest_1, STest_1)
# >>>



############################################################################
##### KONEC #####
