#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/60_PGM/_SRC/m25_02_Singleton.py
"""
Demonstrační definice dekorátoru realizujícího jedináčka.
"""

# print('===== START načítání modulu', __name__, '=====')



#Výpis 25.5: Definice dekorátorů jedináčka v modulu m25_02_Singleton
############################################################################
def singleton(cls):
    """Dekorátor zabezpečující vytvoření jediné instance zadané třídy,
       přičemž funkce spravující vytváření instancí (obálka)
       využívá vlastní atribut"""
    def onCall():
        if onCall.instance is None:
            onCall.instance = cls()
        return onCall.instance
    onCall.instance = None
    return onCall

def singletonNL(cls):
    """Dekorátor zabezpečující vytvoření jediné instance zadané třídy,
       přičemž funkce spravující vytváření instancí (obálka)
       využívá lokální proměnnou dekorátoru uchovanou v uzávěru."""
    instance = None
    def onCall():
        nonlocal instance
        if instance is None:
            instance = cls()
        return instance
    return onCall

class singletonCLS():
    """Dekorátor zabezpečující vytvoření jediné instance zadané třídy,
       definovaný jako třída, jejíž instance fungují jako obálky
       spravující vytváření instancí."""
    def __init__(self, cls):
        self.cls = cls
        self.instance = None
    def __call__(self):
        if self.instance is None:
            self.instance = self.cls()
        return self.instance



# print('===== KONEC načítání modulu', __name__, '=====')
