# -*- coding: utf-8 -*-
#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/60_PGM/_SRC/m28_00_Metatřídy.py
"""
Kopie pasáží se záznamy komunikace se systémem realizovanými v IDLE
a uvedenými ve výpisech kapitoly:  28  Ovlivnění tvorby tříd, metatřídy.

Co se v kapitole naučíte
Kapitola vás seznámí s metatřídami, což jsou objekty umožňující ovlivnit
způsob, jak budou definovány třídy. Nejprve předvede,
jak se prostřednictvím metatřídy definují abstraktní třídy.
Pak vysvětlí, jak může rodičovská třída ovlivnit vytváření svých potomků,
a na závěr vás naučí vytvářet vlastní metatřídy různých druhů.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01_00_Startujeme.
"""



#Výpis 28.1: Definice abstraktní třídy a jejího potomka
############################################################################
from abc import ABCMeta, abstractmethod
# >>> \
class Matka28a(metaclass=ABCMeta):
    def template(self):
        print('Matka28a.template - spouštím metodu action')
        self.action()
        print('Matka28a.template - metoda action ukončena')
    @abstractmethod
    def action(self):   pass

Matka28a()
# Traceback (most recent call last):
#   File "<pyshell#2>", line 1, in <module>
#     Matka28a()
# TypeError: Can't instantiate abstract class Matka28a with abstract methods action
# >>> \
class Dcera28a(Matka28a):
    def action(self):   print("---Spuštěna metoda Dcera28a.action")

da = Dcera28a()
da.template()
# Matka28a.template - spouštím metodu action
# ---Spuštěna metoda Dcera28a.action
# Matka28a.template - metoda action ukončena
# >>>



#Výpis 28.2: Definice třídy s metodou __init_subclass__() převzatá z dokumentace
############################################################################
# >>> \
class C28a:
    def __init_subclass__(cls, /, ord, **kwargs):
        super().__init_subclass__(**kwargs)
        cls.cid = f"C28a->{cls.__name__}({ord}. potomek)"
        cls.__repr__ = lambda self: f"{cls.__name__}_{id(self)%10}"

class C28a1(C28a, ord="1"):    pass

C28a1.cid,   C28a1(),   C28a1()
# ('C28a->C28a1(1. potomek)', C28a1_2, C28a1_4)
# >>>



#Výpis 28.3: Šablona testu funkce metatřídy v modulu m28_01_TestMetaXxx
############################################################################

""" Je uloženo v souboru m28_01_TestMetaXxx.py. """



#Výpis 28.4: Import modulu m28_01_TestMetaXxx
############################################################################
import m28_01_TestMetaXxx
# ===== Vytvářím třídu =====
# Tělo definované třídy Dcera28Xxx spuštěno:
# Tělo definované třídy Dcera28Xxx ukončeno
# ===== Vytvářím instanci =====
# df.data='Fce', df.mtd(1)='Fce(1)',
# type(Dcera28Xxx)=<class 'type'>
# >>>



#Výpis 28.5: Definice metatřídy MetaFce definované jako funkce
############################################################################

""" Je uloženo v souboru m28_02_MetaFce.py. """



#Výpis 28.6: Import modulu m28_02_MetaFce
############################################################################
import m28_02_MetaFce
# ===== Vytvářím třídu =====
# MetaFce.__prepare__:
# ...classname='Dcera28Fce'
# ...supers=(<class 'm28_02_MetaFce.Matka28Fce'>,)
# ...Vracím slovník DICT={'da': 'MF', 'fa': <function __prepare__.<locals>.<lambda> at 0x000002A269844820>}
# Tělo definované třídy Dcera28Fce spuštěno:
# Tělo definované třídy Dcera28Fce ukončeno
# MetaFce:
# ...classname='Dcera28Fce'
# ...supers=(<class 'm28_02_MetaFce.Matka28Fce'>,)
# ...['da', 'fa', '__module__', '__qualname__', '__doc__', 'data', 'mtd']
# ...Vytvořena a inicializována třída <class 'm28_02_MetaFce.Dcera28Fce'>
# ===== Vytvářím instanci =====
# df.data='Fce', df.mtd(1)='Fce(1)', df.da='MF'
# df.fa()='<m28_02_MetaFce.Dcera28Fce object at 0x000001FBA9AF08E0>'
# type(Dcera28Fce)=<class 'type'>
# >>>



#Výpis 28.7: Definice metatřídy MetaCls definované jako třída
############################################################################

""" Je uloženo v souboru m28_03_MetaCls.py. """



#Výpis 28.8: Import modulu m28_03_MetaCls
############################################################################
import m28_03_MetaCls
# ===== Vytvářím třídu =====
# MetaCls.__prepare__:
# ...classname='Dcera28Cls'
# ...supers=(<class 'm28_03_MetaCls.Matka28Cls'>,)
# ...Vracím slovník DICT={'Mcls': 'MC'}
# Tělo definované třídy Dcera28Cls spuštěno:
# Tělo definované třídy Dcera28Cls ukončeno
# MetaCls.__new__:
# ...meta=<class 'm28_03_MetaCls.MetaCls'>
# ...classname='Dcera28Cls'
# ...supers=(<class 'm28_03_MetaCls.Matka28Cls'>,)
# ...['Mcls', '__module__', '__qualname__', '__doc__', 'data', 'mtd']
# ...Vytvořena třída <class 'm28_03_MetaCls.Dcera28Cls'>
# MetaCls.__init__:
# ...classname='Dcera28Cls'
# ...supers=(<class 'm28_03_MetaCls.Matka28Cls'>,)
# ...['Mcls', '__module__', '__qualname__', '__doc__', 'data', 'mtd']
# ...Inicializována třída <class 'm28_03_MetaCls.Dcera28Cls'>
# ===== Vytvářím instanci =====
# dc.data='Cls', dc.mtd(1)='Cls(1)', dc.da='MF'
# dc.fa()='<m28_03_MetaCls.Dcera28Cls object at 0x0000015725A2E700>'
# type(Dcera28Cls)=<class 'm28_03_MetaCls.MetaCls'>
# >>>



#Výpis 28.9: Definice metatřídy MetaObj definované jako objekt
############################################################################

""" Je uloženo v souboru m28_04_MetaObj.py. """



#Výpis 28.10: Import modulu m28_04_MetaObj
############################################################################
import m28_04_MetaObj
# ===== Vytvářím třídu =====
# MetaObj.__prepare__:
# ...self=<m28_04_MetaObj.MetaObj object at 0x000001A6DED4D220>
# ...classname='Dcera28Obj'
# ...supers=(<class 'm28_04_MetaObj.Matka28Obj'>,)
# ...Vracím slovník DICT={'da': 'MF', 'fa': <function MetaObj.__prepare__.<locals>.<lambda> at 0x000002A0F48668B0>}
# Tělo definované třídy Dcera28Obj spuštěno:
# Tělo definované třídy Dcera28Obj ukončeno
# MetaObj.__call__:
# ...self=<m28_04_MetaObj.MetaObj object at 0x000001A6DED4D220>
# ...classname='Dcera28Obj'
# ...supers=(<class 'm28_04_MetaObj.Matka28Obj'>,)
# ...['da', 'fa', '__module__', '__qualname__', '__doc__', 'data', 'mtd']
# ...MetaObj.__new__:
# ......self=<m28_04_MetaObj.MetaObj object at 0x000001A6DED4D220>
# ......classname='Dcera28Obj'
# ......supers=(<class 'm28_04_MetaObj.Matka28Obj'>,)
# ......['da', 'fa', '__module__', '__qualname__', '__doc__', 'data', 'mtd']
# ......Vytvořena třída CLASS=<class 'm28_04_MetaObj.Dcera28Obj'>
# ...MetaObj.__init__:
# ......self=<m28_04_MetaObj.MetaObj object at 0x000001A6DED4D220>
# ......classname='Dcera28Obj'
# ......supers=(<class 'm28_04_MetaObj.Matka28Obj'>,)
# ......['da', 'fa', '__module__', '__qualname__', '__doc__', 'data', 'mtd']
# ......Inicializována třída CLASS=<class 'm28_04_MetaObj.Dcera28Obj'>
# Konec práce MetaObj.call
# ===== Vytvářím instanci =====
# do.data='Cls', do.mtd(1)='Cls(1)', do.da='MF'
# do.fa()='<m28_04_MetaObj.Dcera28Obj object at 0x000001A6DED4D220>'
# type(Dcera28Obj)=<class 'type'>
# >>>



############################################################################
##### KONEC #####
