# -*- coding: utf-8 -*-
#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/60_PGM/_SRC/m28_04_MetaObj.py
"""
Definice metatřídy MetaObj definované jako objekt.
"""

# print('===== START načítání modulu', __name__, '=====')



#Výpis 28.9: Definice metatřídy MetaObj definované jako objekt
############################################################################
class MetaObj:
    def __prepare__(self, classname, supers):
        DICT = {'da': 'MF',  'fa': lambda self: f"{self}"}
        print('MetaObj.__prepare__:', f"{self=}", f"{classname=}",
              f"{supers=}", f"Vracím slovník {DICT=}", sep='\n...')
        return DICT

    def __call__(self, classname, supers, classdict):
        print('MetaObj.__call__:', f"{self=}", f"{classname=}",
              f"{supers=}", f"{list(classdict.keys())}", sep='\n...')
        CLASS = self.__NEW__(classname, supers, classdict)
        self.__INIT__(CLASS, classname, supers, classdict)
        print('Konec práce MetaObj.call')
        return CLASS

    def __NEW__(self, classname, supers, classdict):
        CLASS = type(classname, supers, classdict)
        print('...MetaObj.__new__: ', f"{self=}", f"{classname=}",
              f"{supers=}", f"{list(classdict.keys())}",
              f"Vytvořena třída {CLASS=}", sep='\n......')
        return CLASS

    def __INIT__(self, CLASS, classname, supers, classdict):
        print('...MetaObj.__init__:', f"{self=}", f"{classname=}",
              f"{supers=}", f"{list(classdict.keys())}",
              f"Inicializována třída {CLASS=}", sep='\n......')



############################################################################
# Následuje test funkce metatřídy MetaObj

class Matka28Obj:
    pass

print('===== Vytvářím třídu =====')
class Dcera28Obj(Matka28Obj, metaclass=MetaObj()):
    """Metatřída MetaObj je definována jako objekt."""
    print('Tělo definované třídy Dcera28Obj spuštěno:')
    data = 'Cls'
    def mtd(self, arg):
        return f"{self.data}({arg})"
    print('Tělo definované třídy Dcera28Obj ukončeno')

print('===== Vytvářím instanci =====')
do = Dcera28Obj()
print(f"{do.data=}, {do.mtd(1)=}, {do.da=}\n{do.fa()=}",
      f"\n{type(Dcera28Obj)=}")



# print('===== KONEC načítání modulu', __name__, '=====')
