# -*- coding: utf-8 -*-
#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/60_PGM/_SRC/m29_00_Korutiny_vlákna_procesy.py
"""
Kopie pasáží se záznamy komunikace se systémem realizovanými v IDLE
a uvedenými ve výpisech kapitoly:  29  Korutiny, vlákna, procesy.

Co se v kapitole naučíte
Tato kapitola probírá další z témat, která by vydala na samostatnou publikaci.
Ukáže vám, jak je v Pythonu možné naprogramovat paralelní běh více činností.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01_00_Startujeme.
"""



#Výpis 29.1: Definice a použití jednoduchých korutin
############################################################################
import asyncio
import time
# >>> \
async def say_after(delay, what):
    print(f"Spuštěno v {time.strftime('%X')}: {delay=}, {what=}")
    await asyncio.sleep(delay)
    print(f"Tištěno v {time.strftime('%X')}: {what=}")

# >>> \
async def await21():
    print(f"await21: Start v {time.strftime('%X')}")
    await say_after(2, 'Dva')
    print(f"await21: Mezičas: {time.strftime('%X')}")
    await say_after(1, 'Raz')
    print(f"await21: Konec v {time.strftime('%X')}")

asyncio.run(await21())
# await21: Start v 19:13:19
# Spuštěno v 19:13:19: delay=2, what='Dva'
# Tištěno v 19:13:21: what='Dva'
# await21: Mezičas: 19:13:21
# Spuštěno v 19:13:21: delay=1, what='Raz'
# Tištěno v 19:13:22: what='Raz'
# await21: Konec v 19:13:22
# >>>



#Výpis 29.2: Zabalení korutiny do instance třídy Task
############################################################################
# >>> \
async def task21():
    task2 = asyncio.create_task(say_after(2, 'Dva'))
    print('Mezi vytvořením task2 a task1')
    task1 = asyncio.create_task(say_after(1, 'Raz'))
    await asyncio.sleep(1)
    print(f"task21: Start v {time.strftime('%X')}")
    await task2
    print(f"task21: Mezičas: {time.strftime('%X')}")
    await task1
    print(f"task21: Konec v {time.strftime('%X')}")

asyncio.run(task21())
# Mezi vytvořením task2 a task1
# Spuštěno v 23:35:12: delay=2, what='Dva'
# Spuštěno v 23:35:12: delay=1, what='Raz'
# task21: Start v 23:35:13
# Tištěno v 23:35:13: what='Raz'
# Tištěno v 23:35:14: what='Dva'
# task21: Mezičas: 23:35:14
# task21: Konec v 23:35:14
# >>>



#Výpis 29.3: Analýza datových typů
############################################################################
type(say_after), type(await21), type(task21)
# (<class 'function'>, <class 'function'>, <class 'function'>)
type(say_after(0, "")), type(await21()), type(task21())
# (<class 'coroutine'>, <class 'coroutine'>, <class 'coroutine'>)
# >>>



############################################################################
##### KONEC #####
