#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/60_PGM/_SRC/utils.py
"""
Sada několika demonstračních generátorových funkcí pro použití v ukázkách.
"""
# import datetime;   print(__name__, ':', datetime.datetime.now())
# print('===== START načítání modulu', __name__, '===== ')


def factR(n):
    """Rekurzivní definice faktoriálu."""
    if n<=1 : return 1
    return n * factR(n-1)


def gen2(n: int):
    """Generátor prvních n násobků čísla 11.
    """
    for x in range(11, n*11+1, 11):
        yield x


def gen3(n: int):
    """Generátor prvních n násobků čísla 111.
    """
    for x in range(111, n*111+1, 111):
        yield x


def gen_str(n: int):
    """Generátor n slovních názvů čísel, mazimálně však 5.
    """
    str = ('Raz', 'Dva', 'Tři', 'Čty', 'Pět')
    for x in range(1, n+1):
        yield str[x]


def gen_square(n: int, start: int = 1):
    """Generátor druhých mocnin přirozených čísel
       počínaje číslem start a konče číslem n včetně.
    """
    for x in range(start, n+1):    # Včetně n^2
        yield x*x


def gen_geom(n: int, quotient: float, start: float = 1.):
    """Generátor vracející n členů geometrické řady s kvocientem quotient
       počínaje členem start.
    """
    if n < 1:
        print("geom -- požadován argument >= 1")
        return
    for i in range(1, n+1):
        yield start
        start *= quotient
    return


def gen_fibonacci(n: int):
    """Generátor vracející členy Fibonacciho posloupnosti od 1. do n-tého.
       Argument musí být >= 1;
    """
    n2 = 0  # Hodnota položky n-2
    n1 = 1  # Hodnota položky n-1
    if n < 1:
        print("fibonacci -- požadován argument >= 1")
        return
    for i in range(1, n+1):
        n2, n1 = n1, n2 + n1
        yield (i, n1)
    return


def prdict(d, dict=False, syst=False, msg=''):
    """Vytiskne položky jmenného prostoru zadané instance,
       každou na samostatný řádek.
       Argument syst zadává, zda se budou tisknout i systémové položky.
    """
    if (dict):
        dd = d;
        t  = 'Obsah slovníku'
    else:
        dd = d.__dict__;
        t  = 'Atributy objektu'
    print(f"##### {t}: {msg}")
    for k, v in dd.items():
        if (syst  or  not k.startswith('__')):
            print(f"{k} = {v}")


# def prdict(d, dict=False, syst=False):
#     """Vytiskne položky jmenného prostoru zadané instance,
#        každou na samostatný řádek.
#        Argument syst zadává, zda se budou tisknout i systémové položky.
#     """
#     print("##### Atributy objektu", d)
#     for k, v in d.__dict__.items():
#         if (syst  or  not k.startswith('__')):
#             print(f"{k} = {v}")


def prSK(self, cls, sk, msg=''):
    """Vytiskne oznámení o startu, resp, konci provádění volající metody.
       cls = třída, jejíž metoda tuto metodu volá
       sk = příznak tisku startu (True) či ukončení (False) těla metody
       msg = Případná zpráva za vlastním oznámením
    """
    if not sk: prSK.level -= 1  # Trasovaná metoda končí, zmenšuji odsazení
    print(f'{prSK.level * prSK.sp}{cls.__name__} - ' +
          f'{"START" if sk else "KONEC"}' +
          f'{"" if msg == "" else f" - {msg}"}')
    if sk: prSK.level += 1  # Zvětšuji odsazení pro nižší hladinu
prSK.level = 0;     # Hladina vnoření pro nastavení odsazení
prSK.sp = '   '     # Text odsazení pro znázornění hladiny volání


def prBE(fce, sk, msg=''):
    """Vytiskne oznámení o startu, resp. konci provádění volající funkce.
       fce = funkce volající tuto funkci
       sk = příznak tisku startu (True) či ukončení (False) těla funkce
       msg = Případná zpráva za vlastním oznámením
    """
    if not sk: prBE.level -= 1  # Trasovaná metoda končí, zmenšuji odsazení
    print(#f'{sk=}, {prBE.level=}, {prBE.sp=}{prBE.level*prBE.sp=}\n' +
          f'{prBE.level*prBE.sp}{fce.__name__} - ' +
          f'{"START" if sk else "KONEC"}' +
          f'{"" if msg == "" else f" - {msg}"}')
    if sk: prBE.level += 1  # Zvětšuji odsazení pro nižší hladinu
prBE.level = 0;     # Hladina vnoření pro nastavení odsazení
prBE.sp = '---'     # Text odsazení pro znázornění hladiny volání


def prseq(seq):
    """Vytiskne položky zadané posloupnosti, každou na samostatný řádek."""
    for x in seq: print(x)


# print('===== KONEC načítání modulu''', __name__, '=====')
